function MqDDItem(fieldID, level)
{
	var m_fieldID=fieldID;
	var m_level=level;
	var m_value="";
	
	function SetValue(value)
	{
		m_value=value;
	}
	
	function GetValue()
	{
		return m_value;
	}
	
	this.FieldID=fieldID;
	this.Level=level;
	this.SetValue=SetValue;
	this.GetValue=GetValue;
}

function MqDDItemColl()
{
	var m_ddItemColl = new Array();
	var m_lngCurrentLevel = 1;
	
	function Add(ddItem)
	{
		var index = m_ddItemColl.length;
		m_ddItemColl.length++;
		m_ddItemColl[index]=ddItem;
	}
	
	function Get(itemLevel)
	{
		for(var x=0; x<m_ddItemColl.length; x++)
		{
			if(m_ddItemColl[x].Level==itemLevel)
			{
				return m_ddItemColl[x];
			}
		}
		
		return null;
	}
	
	function Count()
	{
		return m_ddItemColl.length+1;
	}
	
	function IsLastLevel(itemLevel)
	{
		var retVal = false;
		
		if(m_ddItemColl[m_ddItemColl.length-1].Level==itemLevel){
			retVal = true;
		}
		
		return retVal;
	}
	
	function CurrentLevel()
	{
		return m_lngCurrentLevel;
	}
	
	function DoDD(value)
	{
		this.Get(m_lngCurrentLevel).SetValue(value);
		m_lngCurrentLevel++;
	}
	
	function ResetDD()
	{
		m_lngCurrentLevel=1;
		var objDDItem=this.Get(m_lngCurrentLevel);
		if(objDDItem){
			objDDItem.SetValue("");
		}
	}

	this.Add=Add;
	this.Get=Get;
	this.IsLastLevel=IsLastLevel;
	this.Count=Count;
	this.CurrentLevel=CurrentLevel;
	this.DoDD=DoDD;
	this.ResetDD=ResetDD;
}

function MqSLDrillDown(objCenMain, lngItemLevelField)
{
	var m_arrBreadcrumbs=new Array();
	var m_strBreadCrumbs="";
	var m_objCenMain=objCenMain;
	var m_objSumListWin;
	var m_strBaseQueryVal="";
	var m_blnDDIsEnabled=false;
	
	var m_strDisplayVal;
	var m_strFields;
	var m_strTests;
	var m_strVals;
	var m_strRetains;
	var m_strTooltip;
	var m_strFullValue;
	
	var ITEM_LEVEL_FLD_LOC=846;
	var ITEM_LEVEL_FLD_ASSETS=886;
	
	var LOC_LEVEL_1_VAL=g_MqRef.RESX["LOCATION.LEVEL_1"];
	var LOC_LEVEL_2_VAL=g_MqRef.RESX["LOCATION.LEVEL_2"];
	var LOC_LEVEL_3_VAL=g_MqRef.RESX["LOCATION.LEVEL_3"];
	var LOC_LEVEL_4_VAL=g_MqRef.RESX["LOCATION.LEVEL_4"];
	var LOC_LEVEL_5_VAL=g_MqRef.RESX["LOCATION.LEVEL_5"];
	var LOC_LEVEL_6_VAL=g_MqRef.RESX["LOCATION.LEVEL_6"];
	var LOC_LEVEL_7_VAL=g_MqRef.RESX["LOCATION.LEVEL_7"];
	var LOC_LEVEL_8_VAL=g_MqRef.RESX["LOCATION.LEVEL_8"];
	var LOC_LEVEL_9_VAL=g_MqRef.RESX["LOCATION.LEVEL_9"];
	
	var ASSET_LEVEL_1_VAL=g_MqRef.RESX["ASSET.LEVEL_1"];
	var ASSET_LEVEL_2_VAL=g_MqRef.RESX["ASSET.LEVEL_2"];
	
	if (lngItemLevelField==""){
		lngItemLevelField=ITEM_LEVEL_FLD_ASSETS;
	}

	var m_lngItemLevelField=lngItemLevelField;
	
	if(m_lngItemLevelField==ITEM_LEVEL_FLD_LOC){
		m_strBaseQueryVal=LOC_LEVEL_1_VAL;
	}else{
		if(m_lngItemLevelField==ITEM_LEVEL_FLD_ASSETS){
			m_strBaseQueryVal=ASSET_LEVEL_1_VAL;
		}else{
			if(m_lngItemLevelField==806){
				m_strBaseQueryVal="Template";
			}else{
				if(m_lngItemLevelField==1467){
					m_strBaseQueryVal="<not null>";
				}
			}
		}
	}
	
	function GetSLWin()
	{
		if(!m_objSumListWin){
			if(m_objCenMain){
				m_objSumListWin=m_objCenMain.objFrames.GetFrameWindow(SUMMARY_LIST_FRAME_ID);
			}		
		}
		return m_objSumListWin;
	}
	
	function TriggerDrillDownQuery(lngItemID)
	{
		var objLink=GetSLWin().document.getElementById("Link_" + lngItemID);
		
		if(objLink)
		{
			window.open(objLink.innerHTML);
		}else{
			ApplyQuery(lngItemID);
		}
	}
	
	function GetCurrentLevel(lngItemID)
	{
		var objLevel=GetSLWin().document.getElementById("Level_" + lngItemID);
		var strLevel="";
		
		if(objLevel){
			strLevel=objLevel.innerHTML;
		}
		return strLevel;
	}
	
	function GetTopLevel(lngItemID)
	{
		var objTopLevel=GetSLWin().document.getElementById("TopLevel_" + lngItemID);
		var strTopLevel="";
		
		if(objTopLevel){
			strTopLevel=objTopLevel.innerHTML;
		}
		return strTopLevel;
	}
	
	function GetField(lngItemID)
	{
		var lngField;
		var strQryVal=GetCurrentLevel(lngItemID);
		if(strQryVal!=""){		
			if(m_lngItemLevelField==ITEM_LEVEL_FLD_LOC){
				if(strQryVal==LOC_LEVEL_1_VAL){
					lngField=840;
				}else{
					if(strQryVal==LOC_LEVEL_2_VAL){
						lngField=841;
					}else{
						if(strQryVal==LOC_LEVEL_3_VAL){
							lngField=842;
						}else{
							if(strQryVal==LOC_LEVEL_4_VAL){
								lngField=843;
							}else{
								if(strQryVal==LOC_LEVEL_5_VAL){
									lngField=844;
								}else{
									if(strQryVal==LOC_LEVEL_6_VAL){
										lngField=855;
									}else{
										if(strQryVal==LOC_LEVEL_7_VAL){
											lngField=856;
										}else{
											if(strQryVal==LOC_LEVEL_8_VAL){
												lngField=857;
											}else{
												if(strQryVal==LOC_LEVEL_9_VAL){
													lngField=858;
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}else{
				if(m_lngItemLevelField==ITEM_LEVEL_FLD_ASSETS){
					if(strQryVal==ASSET_LEVEL_1_VAL){
						lngField=1092;
					}else{
						if(strQryVal==ASSET_LEVEL_2_VAL){
							lngField=1093;
						}
					}
				}else{
					if(m_lngItemLevelField==806){
						if(strQryVal=="Template"){
							lngField=30;
						}
					}
				}
			}
		}
		
		return lngField;
	}
	
	function GetNextLevel(lngItemID)
	{
		var strNextLevel;
		var strQryVal=GetCurrentLevel(lngItemID);
		var strTopLevelVal=GetTopLevel(lngItemID);
		if(strQryVal!=""){		
			if(m_lngItemLevelField==ITEM_LEVEL_FLD_LOC){
				if(strQryVal==LOC_LEVEL_1_VAL){
					strNextLevel=LOC_LEVEL_2_VAL;
				}else{
					if(strQryVal==LOC_LEVEL_2_VAL){
						strNextLevel=LOC_LEVEL_3_VAL;
					}else{
						if(strQryVal==LOC_LEVEL_3_VAL){
							strNextLevel=LOC_LEVEL_4_VAL;
						}else{
							if(strQryVal==LOC_LEVEL_4_VAL){
								strNextLevel=LOC_LEVEL_5_VAL;
							}else{
								if(strQryVal==LOC_LEVEL_5_VAL){
									strNextLevel=LOC_LEVEL_6_VAL;
								}else{
									if(strQryVal==LOC_LEVEL_6_VAL){
										strNextLevel=LOC_LEVEL_7_VAL;
									}else{
										if(strQryVal==LOC_LEVEL_7_VAL){
											strNextLevel=LOC_LEVEL_8_VAL;
										}else{
											if(strQryVal==LOC_LEVEL_8_VAL){
												strNextLevel=LOC_LEVEL_9_VAL;
											}else{
												if(strQryVal==LOC_LEVEL_9_VAL){
													strNextLevel=null;
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}else{
				if(m_lngItemLevelField==ITEM_LEVEL_FLD_ASSETS){
					if(strQryVal==ASSET_LEVEL_1_VAL){
						strNextLevel=ASSET_LEVEL_2_VAL;
					}else{
						if(strQryVal==ASSET_LEVEL_2_VAL){
							strNextLevel=ASSET_LEVEL_2_VAL;
						}else{
							if(strQryVal=="Item"){
								strNextLevel=null;
							}
						}
					}
				}else{
					if(m_lngItemLevelField==806){
						if(strQryVal=="Template"){
							strNextLevel="Employee";
						}else{
							if(strQryVal=="Employee"){
								strNextLevel=null;
							}
						}
					}
				}
			}
		}
		return strNextLevel;
	}
	
	function GetValue(lngItemID, blnDisplay)
	{
		var objName=GetSLWin().document.getElementById("DD_Fld_Value_Full_" + lngItemID);
		
		if(!objName || blnDisplay==true){
			objName=GetSLWin().document.getElementById("DD_Fld_Value_" + lngItemID);
		}
		
		var strValue;
		
		if(objName){
			strValue=objName.innerHTML;
		}
		
		if(!blnDisplay){
			strValue=g_MqRef.MqStr.MqHtmlDecode(strValue, false);
		}
		return strValue;
	}
	function HandleSetDDVals(lngItemID, strDisplayVal, strFields, strTests, strVals, strRetains, strTooltip, strFullValue)
	{
		var blnReturn=false;
		var strValue="";
		var strTooltipValue="";
		var strDDFields="";
		var strDDTests="";
		var strDDVals="";
		var strDDRetains="";
		var strValueDisplay="";

		if(typeof(strFields) != 'undefined' && typeof(strTests) != 'undefined' && typeof(strVals) != 'undefined' && typeof(strRetains) != 'undefined' && typeof(strTooltip) != 'undefined' && typeof(strFullValue) != 'undefined'){
			g_VWS.SummaryList().DDItemColl().ResetDD();
			strDDFields=strFields;
			strDDTests=strTests;
			strDDVals=strVals;
			strDDRetains=strRetains;
			strValue=strFullValue;
			strValueDisplay=strDisplayVal;
			strTooltipValue=strTooltip;
			blnReturn=true;
		}else{
			if(lngItemID==0){
				g_VWS.SummaryList().DDItemColl().ResetDD();

				strDDFields=m_lngItemLevelField;
				strDDTests="0";
				strDDVals=m_strBaseQueryVal;
				strDDRetains="And";
				strValue="(Start)";
				strValueDisplay=strValue;
				strTooltipValue="";
				blnReturn=true;
			}else{
				var objLvl;
				if(g_VWS.SummaryList().DDItemColl().Count() > 0){
					objLvl=g_VWS.SummaryList().DDItemColl().Get(g_VWS.SummaryList().DDItemColl().CurrentLevel());
				}
				var strAddFlds="";
				var strAddTests="";
				var strAddVals="";
				var strAddRets="";
				
				if(objLvl)
				{
					var lngField=objLvl.FieldID;
					g_VWS.SummaryList().DDItemColl().DoDD(lngItemID);
					strValueDisplay=GetValue(lngItemID, true);
					var strValue=strValueDisplay;
					strDDFields=lngField;
					strDDTests="0";
					strDDVals=strValue;
					strDDRetains="And";
					//strTooltipValue=GetCurrentLevel(lngItemID);				
					blnReturn=true;
				}else{
					var lngField=GetField(lngItemID);
					var strValue=GetValue(lngItemID, false);
					strValueDisplay=GetValue(lngItemID, true);
					var strNextLevel=GetNextLevel(lngItemID);
					
					if(m_lngItemLevelField==ITEM_LEVEL_FLD_ASSETS && lngField==1092 && IsAssetView()){
							strAddFlds=";806";
							strAddTests=";0";
							strAddVals=";Asset Type";
							strAddRets=";And";
					}	
				}
				if(lngField && strNextLevel){
					
					if(strValue){
						strDDFields=lngField+";" + m_lngItemLevelField + strAddFlds;
						strDDTests="0;0" + strAddTests;
						strDDVals=strValue+";"+strNextLevel + strAddVals;
						strDDRetains="And;And" + strAddRets;
						strTooltipValue=GetCurrentLevel(lngItemID);				
						blnReturn=true;
					}
				}
			}
		}
		m_objCenMain.m_objSLInput.SetDDFilters(strDDFields, strDDTests, strDDVals, strDDRetains);
		
		if(blnReturn){
			StoreCurrentDD(strValueDisplay, strDDFields, strDDTests, strDDVals, strDDRetains, strTooltipValue, strValue);
			ApplyToBreadCrumbs(strValueDisplay, strDDFields, strDDTests, strDDVals, strDDRetains, strTooltipValue, strValue);
		}
		
		return blnReturn;
	}
	
	function StoreCurrentDD(strDisplayVal, strFields, strTests, strVals, strRetains, strTooltip, strFullValue)
	{
		m_strDisplayVal=strDisplayVal;
		m_strFields=strFields;
		m_strTests=strTests;
		m_strVals=strVals;
		m_strRetains=strRetains;
		m_strTooltip=strTooltip;
		m_strFullValue=strFullValue;
	}
	
	function ApplyQueryFromBC(strDisplayVal, strFields, strTests, strVals, strRetains, lngSelectedIndex, strTooltip, strFullValue)
	{
		m_arrBreadcrumbs.length=lngSelectedIndex;
		strFullValue=unescape(strFullValue);
		strVals=unescape(strVals);
		
		ApplyQuery(null, strDisplayVal, strFields, strTests, strVals, strRetains, strTooltip, strFullValue);
	}
	
	function ApplyQuery(lngItemID, strDisplayVal, strFields, strTests, strVals, strRetains, strTooltip, strFullValue)
	{
		if(HandleSetDDVals(lngItemID, strDisplayVal, strFields, strTests, strVals, strRetains, strTooltip, strFullValue)){	
			//clear the search when drilling down
			var blnResetQry=true;
			if(lngItemID!=null){
				if(lngItemID==0){
					blnResetQry=false;
				}
			}
			if(blnResetQry){
				m_objCenMain.m_objSLInput.SetTextSearchValue(SEARCH_MSG);
			}
			m_objCenMain.m_objSLMgr.ApplySearchToSL(false, false, m_objCenMain.m_objSLInput, true);
		}
	}
	
	function InitDDStart()
	{
		ApplyQuery(0);
	}
	
	function SetDDBreadCrumbs()
	{
		var objBreadcrumbs=GetSLWin().document.getElementById("DDBreadcrumbs");
		
		if(objBreadcrumbs){
			objBreadcrumbs.innerHTML=m_strBreadCrumbs;
		}
	}
	
	function ApplyToBreadCrumbs(strCaption, strFields, strTests, strVals, strRetains, strTooltip, strFullValue)
	{
		var lngIndex=m_arrBreadcrumbs.length;
		m_arrBreadcrumbs.length=lngIndex+1;
		m_arrBreadcrumbs[lngIndex]=new Array(strCaption, strFields, strTests, strVals, strRetains, strTooltip, strFullValue);
		
		m_strBreadCrumbs=GenerateBreadCrumbs(m_arrBreadcrumbs);
	}
	
	function GenerateBreadCrumbs(arrBreadcrumbs)
	{
		var strBreadCrumbs=GetToggleDDHTML();
		
		for(x=0;x<arrBreadcrumbs.length;x++){
			var arrSearchLevel=arrBreadcrumbs[x];
			var QUOTE="\"";
			
			strBreadCrumbs+="<a href='#' onclick='parent.m_objSLDD.ApplyQueryFromBC(" + QUOTE + arrSearchLevel[0] + QUOTE + "," + QUOTE +
											arrSearchLevel[1] + QUOTE + "," + QUOTE + arrSearchLevel[2] + QUOTE + "," + 
											QUOTE + escape(arrSearchLevel[3]) + QUOTE + "," + QUOTE + arrSearchLevel[4] + QUOTE + ", " + x + 
											", " + QUOTE + arrSearchLevel[5] + QUOTE + ", " + QUOTE +  escape(arrSearchLevel[6]) + QUOTE + 
											")' class='SLBreadCrumbs' title='" + arrSearchLevel[5] + "'>" + arrSearchLevel[0] + "</a>";
		}
		
		
		return strBreadCrumbs;
	}
	
	function GetToggleDDHTML()
	{
		var strToggleHTML="";
		if(m_objCenMain){
			var objTBar=m_objCenMain.objFrames.GetFrameWindow(TOOLBAR_FRAME_ID);
			if(objTBar){
				if(IsDDQueryForView(objTBar.m_lngQueryID)){
					var buttonClass="fa fa-times";
					var tooltip=g_MqRef.RESX["TT.TURN_OFF_DD_IN_SL"];			
					
					if(!DDIsEnabled()){
						buttonClass="fa-solid fa-folder-tree";
						tooltip=g_MqRef.RESX["TT.TURN_ON_DD_IN_SL"];	
					}

					strToggleHTML="<a href='#' class='SLBreadCrumbs' onclick='parent.m_objSLDD.ToggleDD()' title='" + tooltip + "'><i class='" + buttonClass + "'></i></a>";
				}
			}
		}
		return strToggleHTML;
	}
	function ToggleDD()
	{
		if(DDIsEnabled()){
			DisableDD();
		}else{
			EnableDD();
		}
	}
	function DisableDD()
	{
		m_blnDDIsEnabled=false;
		if(m_lngItemLevelField==ITEM_LEVEL_FLD_ASSETS || m_lngItemLevelField==ITEM_LEVEL_FLD_LOC){
			if(IsAssetView()){
				TurnOnSearchWithinDD();
			}
			ApplyQuery(0, "", "", "", "", "", "", "");
		}
		m_strBreadCrumbs=GetToggleDDHTML();
		
		SetDDBreadCrumbs();
	}
	
	function EnableDD()
	{
		m_blnDDIsEnabled=true;
		if(m_lngItemLevelField==ITEM_LEVEL_FLD_ASSETS || m_lngItemLevelField==ITEM_LEVEL_FLD_LOC){
			ResetDD();
		}
		InitDDStart();
	}
	
	function HandleEnableDisableDD(lngQueryID)
	{
		if(IsAssetView() || IsManageAssetView() || IsManageLocationsView()){
			if(IsDDQueryForView(lngQueryID)){
				EnableDD();
			}else{
				DisableDD();	
			}
			return true;
		}else{
			return false;
		}		
	}
	
	function ResetDD()
	{
			m_arrBreadcrumbs.length=0;
			m_objCenMain.m_objSLInput.SetExtraExpression("");
	}
	
	function DDIsEnabled()
	{
		return m_blnDDIsEnabled;
	}
		
	function RefreshToCurrentDD()
	{
		if(m_strDisplayVal){
			if(m_arrBreadcrumbs){
				if(m_arrBreadcrumbs.length>0){
					m_arrBreadcrumbs.length=m_arrBreadcrumbs.length-1;
				}
			}
		}
		ApplyQuery(null, m_strDisplayVal, m_strFields, m_strTests, m_strVals, m_strRetains, m_strTooltip, m_strFullValue);
	}
	
	function TurnOnSearchWithinDD()
	{
		if(m_lngItemLevelField==ITEM_LEVEL_FLD_ASSETS){
			if(IsAssetView()){
				m_objCenMain.m_objSLInput.SetExtraExpression("([tblUsageType].[tName]<>'Asset Type' OR [tblUsageType].[tName] IS NULL)");
			}
		}
	}
	
	function TurnOffSearchWithinDD()
	{
		if(m_lngItemLevelField==ITEM_LEVEL_FLD_ASSETS){
			if(IsAssetView()){
				m_objCenMain.m_objSLInput.SetExtraExpression("");
			}
		}
	}
	
	function IsDDQueryForView(lngQueryID)
	{
		const QRY_ID_ASSET_TYPES=1;
		const QRY_ID_ASSETS=10;
		const QRY_ID_LOCATIONS=10;
		var retVal = true;
		
		if(IsAssetView() && lngQueryID!=QRY_ID_ASSETS){
			retVal=false;
		}else{
			if(IsManageAssetView() && lngQueryID!=QRY_ID_ASSET_TYPES)
			{
				retVal=false;
			}else{
				if(IsManageLocationsView() && lngQueryID!=QRY_ID_LOCATIONS)
				{
					retVal=false;
				}
			}
			//else other views for other projects it is a valid query for DD
		}
		return retVal;
	}
	this.SetDDBreadCrumbs=SetDDBreadCrumbs;
	this.TriggerDrillDownQuery=TriggerDrillDownQuery;
	this.InitDDStart=InitDDStart;
	this.ApplyQueryFromBC=ApplyQueryFromBC;
	this.DisableDD=DisableDD;
	this.EnableDD=EnableDD;
	this.HandleEnableDisableDD=HandleEnableDisableDD;
	this.DDIsEnabled=DDIsEnabled;
	this.RefreshToCurrentDD=RefreshToCurrentDD;
	this.ResetDD=ResetDD;
	this.TurnOnSearchWithinDD=TurnOnSearchWithinDD;
	this.TurnOffSearchWithinDD=TurnOffSearchWithinDD;
	this.IsDDQueryForView=IsDDQueryForView;
	this.ToggleDD=ToggleDD;
	
	function IsAssetView()
	{
		return (g_VWS.ViewID==g_VWS.WebViews.ASSET_LIBRARY || 
				g_VWS.ViewID==g_VWS.WebViews.SW_ASSET_LIBRARY || 
				g_VWS.ViewID==g_VWS.WebViews.DEPARTMENT_ASSETS || 
				g_VWS.ViewID==g_VWS.WebViews.ASSET_LIBRARY_MOBILE);
	}
	
	function IsManageAssetView()
	{
		return (g_VWS.ViewID==g_VWS.WebViews.MANAGE_ASSET_TYPES || 
				g_VWS.ViewID==g_VWS.WebViews.MANAGE_SW_ASSET_TYPES);
	}
	
	function IsManageLocationsView()
	{
		return (g_VWS.ViewID==g_VWS.WebViews.MANAGE_LOCATIONS);
	}
}