function VNGridUIRulesController (oGrid, SL_UI_Settings, arrColCenDataTypes, oDataView) 
{
	const COL_ID_REC_ID = "RECID";
	const COL_ID_URL_LINK = "LINK";

	var _self = this;
	var UIRuleProps = {};
	var m_Grid = oGrid;
	var m_DataView = oDataView;
	var curRule = 0;
	var infoStr = "";
	if(typeof SL_UI_Settings !== 'undefined') {infoStr = SL_UI_Settings;}
	var curStyling;
	var colsToStyle = [];
	var styleRules = [];
	var divider = 2;
	var rule = [];
	var priSplit;
	var m_arrCenDataTypes = arrColCenDataTypes;
	
	function LoadGridUIPropRules() {
		var curRule;
		
		if (infoStr != undefined) {
			 priSplit = infoStr.split(";");
		}
		
		for (z=0; z < priSplit.length; z++) {
			switch (z % divider) {
				case 0:
					rule[0] = priSplit[z];
					break;
				case 1:
					rule[1] = priSplit[z];
					ApplySingleRule();
					break;
			}
		}
		FormatColData();
	}
	function LoadSingleRuleBypass() {
		ApplySingleRule();
		FormatColData();
	}
	Array.prototype.remove = function() {
        var what;
        var a = arguments;
        var L = a.length;
        var ax;
        while(L && this.length) {
            what = a[--L];
            while((ax = this.indexOf(what)) !== -1) {
                this.splice(ax,1);
            }
        }
        return this;
    };
    function IEincludes(container, value) {
        var returnVal = false;
        var pos = container.indexOf(value);
        if (pos >= 0) {
            returnVal = true;
        }
        return returnVal;
    }
	
	function Apply() {
		LoadGridUIPropRules();
	}
	
	
	function FormatColData()
	{
		var colDateIndexes = [];
		var colCostIndexes = [];
		var curColl;
		var cellVal;
		var dataVal;
		var formattedVal;
		var NumRows = 0;
		var Cell = {};
		
		if(m_Grid)
		{
			try {
				NumRows = m_Grid.getRowsNum();
			} catch(err) {
				NumRows = 0;
			}
			
			if(m_arrCenDataTypes){
				for(var l=0; l<m_arrCenDataTypes.length;l++){
					if(m_arrCenDataTypes[l]==8){
						colDateIndexes.push(l);
					}else{
						if(m_arrCenDataTypes[l]==5){
							colCostIndexes.push(l);
						}
					}
				}
			}
			
			if(colDateIndexes.length > 0 || colCostIndexes.length > 0)	{
				
				//Apply Date and cost formatting
				for (i=0; i < NumRows; i++) {
					for (n=0; n<colDateIndexes.length;n++) {
						curColl = colDateIndexes[n];
						Cell[i] = m_Grid.cellByIndex(i,curColl).getValue();
						cellVal = Cell[i];
						dataVal=g_MqRef.MqStr.ExtractTextFromHTML(cellVal);
						formattedVal=g_MqRef.MqDate.Format(dataVal);
						formattedVal=cellVal.replace(dataVal, formattedVal);
						m_Grid.cellByIndex(i,curColl).setValue(formattedVal);
					}
					for (n=0; n<colCostIndexes.length;n++) {
						curColl = colCostIndexes[n];
						Cell[i] = m_Grid.cellByIndex(i,curColl).getValue();
						cellVal = Cell[i];
						dataVal=g_MqRef.MqStr.ExtractTextFromHTML(cellVal);
						formattedVal=g_MqRef.MqCurr.Format(dataVal);
						formattedVal=cellVal.replace(dataVal, formattedVal);
						m_Grid.cellByIndex(i,curColl).setValue(formattedVal);
					}
				}
			}
		}else{
			if(m_DataView)
			{
				var objContainer = m_DataView._obj;
				if(objContainer)
				{
					var descendents = objContainer.getElementsByTagName('div');
					for (var i = 0; i < descendents.length; ++i) {
						if(descendents[i].innerText=="undefined"){
							descendents[i].innerText="";
						}
					}
				}
			}
		}
	}
	
	function ApplySingleRule() {
		var hdrLabelsArr = [];
		var curChoice;
		var NumRows = 0;
		var Cell = {};
		var color = 0;
		var value = 0;
		var ruleProps;
		var selectedRuleProps = {};
		var values = {};
		var colors = {};
		var splitCellVal = {};
		var curColStyle;
		var temp1 = [];
		var temp2 = [];
		var splitColor = "|1";
		var splitFlag = "|2";
		var curCell = {match:"",value:""};
		
		try {
			hdrLabelsArr = m_Grid.hdrLabels;
		} catch(err) {
			hdrLabelsArr = [];
		}
		
		if (typeof m_arrColFieldIDs !== 'undefined') {
			if(rule[0]) {
				curColStyle = m_arrColFieldIDs.indexOf(rule[0]);
			} else {
				curColStyle = 0;
			}
		}
			
		for (n=1; n<rule.length; n++) {
			if (IEincludes(rule[n],splitColor)) {
				temp1 = rule[n].split(splitColor);
				curStyling = 1;
			} else if (IEincludes(rule[n],splitFlag)) {
				temp1 = rule[n].split(splitFlag);
				curStyling = 2;
			}
		}
	
		for (n=0; n < temp1.length; n++) {
			temp2[n] = temp1[n].split("|");
		}
		for (n=0; n < temp2.length; n++) {
			temp2[n].remove("");
		}
		
		try {
			NumRows = m_Grid.getRowsNum();
		} catch(err) {
			NumRows = 0;
		}

		if(temp2 != undefined) {
			for (i=0; i < temp2.length; i++) {
				selectedRuleProps = temp2[i];
				for (s=0; s< selectedRuleProps.length; s++) {
					switch (s % divider) {
						case 0:
							values[value] = selectedRuleProps[s];
							value++;
							break;
						case 1:
							colors[color] = selectedRuleProps[s];
							color++;
							break;
					}
				}
			}
		}
		if (g_MqRef.MqBrowser.mobile) {
            ApplyMobileStyling(rule,values,colors);
        } else {
            //Apply color or Flag
            if (curColStyle > 0) {
                for (i=0; i < Object.keys(values).length; i++) {
                    curChoice = (values[i]);
                    for (n=0; n < NumRows; n++) {
                        Cell[n] = m_Grid.cellByIndex(n,curColStyle).getValue();
                        curCell.value = Cell[n];
                        splitCellVal = Cell[n].split("<",2);
                        curCell.match = splitCellVal[1].split(">",2);
                        if (curCell.match[1] === curChoice) {
                            switch(curStyling) {
                                case 0:
                                    break;
                                case 1:
                                    $( "a" ).css("color","inherit");
                                    m_Grid.cellByIndex(n, curColStyle).setTextColor(colors[i]);
                                    break;
                                case 2:
                                    var strLink=curCell.match[0];
									var strValue=curCell.match[1];
									var LINK_CLASS='class="SLGridLink"';
									var FLAG_HTML="<i class='fa fa-flag'></i> ";
									strLink=strLink.replace(LINK_CLASS, LINK_CLASS +' style="color:' + colors[i] +'"');
									
									m_Grid.cellByIndex(n, curColStyle).setValue( "<" + strLink + "> " + FLAG_HTML + strValue);
									break;
                            }
                        }
                    }
                }
            }
        }
	}

    function ApplyMobileStyling(rule,values,colors) {
        var temp;
        var cssProp = "";
        var style = document.createElement("style");
        style.type = "text/css";
        for (i=0; i < Object.keys(values).length; i++) {
            temp = undefined;
            if(rule[0] == "18") {
                cssProp = "background-color";
            } else {
                cssProp = "color";
            }
            temp = document.getElementsByClassName(rule[0] + values[i]);
            var tempVal = values[i].replace(" ", "_");
            style.innerHTML += ".color"
                            + rule[0] + tempVal + " {"
                            + cssProp +":" + colors[i] +"}";
        }
        document.getElementsByTagName("head")[0].appendChild(style);
    }
	
		function InitDtsRecordList( projectID , fieldID,  recID)
		{
			m_Grid.setImagePath("/connect/js/codebasegrid/imgs/");
			m_Grid.setSkin("dhx_skyblue");			
			//m_Grid.attachEvent("onMouseOver", OnMouseOver );
					
			LoadFromURL( projectID , fieldID,  recID );
		}

		// Needs g_VWS.URL().BaseVDURL()
		function LoadFromURL(projID,  dtsFldID, recID)
		{
			var rest= new RESTClient();
			rest.Initialize( g_VWS.URL().BaseVDURL() );
       
			rest.Get( "vzuilist/" + projID + "/GetListXML?FieldID=" + g_MqRef.MqStr.MqEncodeURIComponent(dtsFldID) 
				+ "&DtsRecordID=" + g_MqRef.MqStr.MqEncodeURIComponent(recID))
			.then(OnResponseLoad);
		}
	
		function OnResponseLoad(response)
		{
			try
			{
				if (response)
				{
					const jData=response.responseText;
					if( jData){						
						m_Grid.parse( jData);
						PostInitGrid(m_Grid);
					}
				}
			
			}catch (e){
				console.log(e);
			}
		}

		function PostInitGrid( grid)
		{
			// Add hover menu
			var objData=document.getElementById("HoverMenu");
			if(objData){
				const htmlMenu=objData.innerHTML;
				
				if (htmlMenu)
				{
					var NumRows = 0;
					// Attach to the first column, which by convention is the ID and hidden
					// Same as: attachToCol=m_Grid.getColIndexById( COL_ID_REC_ID);
					var attachToCol=0; //grid.getColumnsNum()-1; 

					try {
						NumRows = grid.getRowsNum();
					} catch(err) {
						NumRows = 0;
					}
				
					for (i=0; i < NumRows; i++) {

						let cellVal = grid.cellByIndex(i, attachToCol).getValue();
						let id=grid.getRowId(i);
						let rowMenu=htmlMenu.replace(/{nID}/g, id );
						let formattedVal= cellVal + rowMenu;
						grid.cellByIndex(i, attachToCol).setValue(formattedVal);
						grid.cellByIndex(i, attachToCol).setAttribute('title'," ");
						
					}
				}
			}
					
		}

		function GetRowLink( row_id )
		{
			// By convention, we get the link from a column with column id LINK
			// The id of the row is the same as the recID.
			const linkCol=m_Grid.getColIndexById( COL_ID_URL_LINK);
			return m_Grid.cellById( row_id, linkCol).getValue();
		}
		
	_self.Apply=Apply;
	_self.LoadGridUIPropRules = LoadGridUIPropRules;
	_self.LoadSingleRuleBypass = LoadSingleRuleBypass;	
    _self.IEincludes = IEincludes;
	_self.InitDtsRecordList=InitDtsRecordList;
	_self.GetRowLink=GetRowLink;
}

function VNSLGridController(oGrid, g_MqRef, loadRowFunc, oSLDDObj, OnItemCheckFunction) {
    var _self=this;
    var m_IsRecordLoading = false;
    var m_rowFunc;
    var m_itemCheckFunc;
    function GetCurrentGrid() {
        return oGrid;
    }
    function GetLoadRowFunction () {
        return loadRowFunc;
    }
    function GetOnItemCheckFunction () {
        return OnItemCheckFunction;
    }
    function GetIDsStr(str, findVal, replaceVal) {
        var regExp=new RegExp(findVal,"g");
        return str.replace(regExp, replaceVal);
    }
    function GetRecordLoadingStatus() {
        return m_IsRecordLoading;
    }
    function SetRecordLoadingStatus(loaded) {
        m_IsRecordLoading = loaded;
    }
    function SetVIZORSLStyle(selColor, selBorderColor) {
        GetCurrentGrid().setStyle("","","border-top:1px solid" + selBorderColor 
					+ "; border-bottom:1px solid " + selBorderColor + ";","border-top:1px solid " 
					+ selBorderColor + "; border-bottom:1px solid " + selBorderColor 
					+ "; background-color:" + selColor + ";");
    }
    function GetLastColNum () {
        return GetCurrentGrid().getColumnsNum()-1;
    }
    function GetSLDDHasMoreObj(lngRowID) {
        return document.getElementById("DD_Has_More_" + lngRowID);
    }
    function GetSLDDObj() {
        if(typeof oSLDDObj !== "undefined") {
            return oSLDDObj;
        }         
    }
    function GetVNSelectedRowsIDs () {
        var gridObjRef = GetCurrentGrid();
        var m_lastColNum = GetLastColNum();
        var strIDs = "";
        if(gridObjRef){
            if(gridObjRef.getColType(m_lastColNum)=="ch"){
                strIDs=gridObjRef.getCheckedRows(m_lastColNum);
                strIDs = GetIDsStr(strIDs,",",";");
            }
        }
        if(g_MqRef.MqStr.Right(strIDs, 1)===";"){
            strIDs=g_MqRef.MqStr.Left(strIDs, strIDs.length-1);
        }
        return strIDs;
    }
    function GetSelectedRowsNum() {
        var lngNum=0;
        var strSelected= GetVNSelectedRowsIDs();
            
        if(strSelected !== ""){
            var arrSelected=strSelected.split(";");
            lngNum = arrSelected.length;
        }
        return lngNum;
    }
    function GetGridParamStr(strLeftParam, strDefaultVal, strRightParam) {
        return strLeftParam + "," + strDefaultVal + "," + strRightParam;
    }
    function ExecuteFunctionByName(functionName, context /*, args */) {
        var args = Array.prototype.slice.call(arguments, 2);
        var namespaces = functionName.split(".");
        var func = namespaces.pop();
        for(var i = 0; i < namespaces.length; i++) {
            context = context[namespaces[i]];
        }
        return context[func].apply(context, args);
    }
    function LoadSelectedItemFunction(lngRowID, lngCellID) {
        var loadFunc = GetLoadRowFunction();
        if(GetCurrentGrid()){
            if(typeof lngCellID == Number) {
                ExecuteFunctionByName(loadFunc, window, [lngRowID,lngCellID]);
            }else {
                ExecuteFunctionByName(loadFunc, window, lngRowID);
            }
        } else {
            ExecuteFunctionByName(loadFunc, window, lngRowID);
        }
    }
    function LoadSelectedItem(lngRowID, lngCellID) {
        var gridObjRef = GetCurrentGrid();
        if(gridObjRef){
            LoadSelectedItemFunction(lngRowID, lngCellID);
        }else{
            LoadSelectedItemFunction(lngRowID);
        }
        SetRecordLoadingStatus(true);
    }
    function ToggleCheckBoxSelection(lngRowID, lngLastCol) {
        var gridObjRef = GetCurrentGrid();
        var m_itmCheckFunc = new GetOnItemCheckFunction();
        if (gridObjRef.cells(lngRowID,lngLastCol).getValue()=="0"){
            gridObjRef.cells(lngRowID,lngLastCol).setValue(1);
            m_itmCheckFunc(lngRowID, lngLastCol, true);
        }else{
            gridObjRef.cells(lngRowID,lngLastCol).setValue(0);
            m_itmCheckFunc(lngRowID, lngLastCol, false);
        }
    }
    function OnGridRowClick(lngRowID, lngCellID) {
		var gridObjRef = GetCurrentGrid();
        var gridSLDDObj = GetSLDDObj();
        if(gridSLDDObj) {
			if(gridSLDDObj.DDIsEnabled()){
				var objHasMoreDD = GetSLDDHasMoreObj(lngRowID);
				if(objHasMoreDD) {

					if(objHasMoreDD.innerHTML==g_MqRef.RESX.Get("YES") ) {
						gridSLDDObj.TriggerDrillDownQuery(lngRowID);
					} else {
						LoadSelectedItem(lngRowID, lngCellID);
					}
				} else {
					gridSLDDObj.TriggerDrillDownQuery(lngRowID);
				}
			} else {
				LoadSelectedItem(lngRowID, lngCellID);
			}
        } else {
            LoadSelectedItem(lngRowID, lngCellID);
        }
    }
    
    function OnGridRowSelect(lngRowID, lngCellID) {
        var gridObjRef = GetCurrentGrid();
        if(gridObjRef){
            var lngLastCol= GetLastColNum();
            var lngNumSelIssues = GetVNSelectedRowsIDs();
            if(gridObjRef.getColType(lngLastCol)=="ch"){
                if(GetRecordLoadingStatus() == true) {
                    if(lngNumSelIssues == 0) {
                        gridObjRef.clearSelection();
                    } else {
                        ToggleCheckBoxSelection(lngRowID, lngLastCol);
                    }
                    SetRecordLoadingStatus(false);
                } else {
                    ToggleCheckBoxSelection(lngRowID, lngLastCol);
                }
            } 
        }
    }
    function LastRowNum() {
	    //Get the number of rows of an SL object
		var o_objSLFrame = objFrames.GetFrameWindow(SUMMARY_LIST_FRAME_ID);
		var o_SLObj = o_objSLFrame.mDataGrid;
		var numRows = 0;
		if(o_SLObj) {
			numRows = o_SLObj.getRowsNum();
		}
		return numRows;
	}
    function GetRowIndexForRecNumber(recNum)
	{
		var recRowIndex=-1;
		
		if (mDataGrid)
		{
			mDataGrid.forEachRow(function(rowID){
				var strRecID = rowID;
				if(strRecID==recNum)
				{
					recRowIndex=mDataGrid.getRowIndex(rowID);
				}
			});
		}
		return recRowIndex;
	}
	function GetRecNumberAtIndex(rowIndex)
	{
		var recNumber=0;
		
		if (mDataGrid)
		{
			recNumber=mDataGrid.getRowId(rowIndex);
		}
		return recNumber;
	}
    _self.GetCurrentGrid = GetCurrentGrid;
    _self.GetRecordLoadingStatus = GetRecordLoadingStatus;
    _self.SetRecordLoadingStatus = SetRecordLoadingStatus;
    _self.SetVIZORSLStyle = SetVIZORSLStyle;
    _self.GetLastColNum = GetLastColNum;
    _self.GetSLDDHasMoreObj = GetSLDDHasMoreObj;
    _self.GetSLDDObj = GetSLDDObj;
    _self.GetSelectedRowsNum = GetSelectedRowsNum;
    _self.GetGridParamStr = GetGridParamStr;
    _self.LoadSelectedItem = LoadSelectedItem;
    _self.GetVNSelectedRowsIDs = GetVNSelectedRowsIDs;
    _self.ToggleCheckBoxSelection = ToggleCheckBoxSelection;
    _self.OnGridRowClick = OnGridRowClick;
    _self.OnGridRowSelect = OnGridRowSelect;
    _self.LastRowNum = LastRowNum;
	_self.GetRowIndexForRecNumber=GetRowIndexForRecNumber;
	_self.GetRecNumberAtIndex=GetRecNumberAtIndex;
}
