
// ----- MqVecWebSession.js

function VecWebSession()
{
	var m_oLoadDataMgr; // Created in the InitFields
	var m_oViewFields= new CMqFieldCol();
	var m_oWorkFlowMgr; // Created in the InitFields
	var m_oWebSessURL=new CMqWebSessionURL();
	var m_oRecMgr;	// Created in the InitFields
	var m_objSL=new CMqSummaryList();	
	var m_oMacros=new CMqMacros(); 
	var m_oURIOpener=new MqURIOpener();
	var m_objReportMgr=new VNReportManager();
	var m_oHTTPRequest=new CMqHTTPRequest_js();
	var m_oVNMainWin;
	var m_objCmdBar;
	var m_VNFeatures = new Array();
	var m_oBrowser = new CMqBrowserDetector();
	var _me=this;
	var m_sViewName;
	var m_VNSettings = new Array();
	var m_blnAdminMode = false;
	var m_VNQueries = new VNQueryCol();
	let _viewFeatures; // a MqFeatures();
	
	function Init(strCurrentVD, strBaseVD, objMainDoc, oMainWindow, vnUser, projectID, viewID, viewName, viewFeatures)
	{
		m_oVNMainWin=new VNMainWindow(oMainWindow, _me); 
		
		m_oWebSessURL.Init(strCurrentVD, strBaseVD);
		
		m_objSL.Init(objMainDoc, oMainWindow);
		
		m_objCmdBar=new CMqCommandBar(oMainWindow, this);
		
		// user group features
		if(this.m_VNFeatures == undefined)
		{
			this.m_VNFeatures = new Array();
		}
		
		// view features object
		_viewFeatures=viewFeatures;
		
		// Current user as VNUser
		if (vnUser)
		{
			_me.User=vnUser;
		}
		
		if (projectID)
		{
			_me.ProjectID=projectID;
		}
		
		if (viewID)
		{
			_me.ViewID=viewID;
		}
		
		if (viewName)
		{
			_me.ViewShortName=viewName;
		}

		_me.CustomCode=oMainWindow.objCustomCode;
		
		_me.MainDoc=objMainDoc;

		m_VNQueries.Load();
	}
	
	function InitFields(strXMLFields,strRevisionHistoryFieldID,oMqAutoList, oDisplayElements, fnInitDeclaredBizRules, strDataHTMLDocument)
	{
		
		// Init View Fields
		var objRecordset=new CMqRecordset(strXMLFields, m_oViewFields.GetFieldIDName()); 
		m_oViewFields.Load(objRecordset);		
		m_oViewFields.SetRevisionHistoryFieldID(strRevisionHistoryFieldID);
		
		// Init LoadDataMgr and other objects
		m_oLoadDataMgr= new CMqLoadDataMgr(m_oViewFields, strDataHTMLDocument);
	
		m_oURIOpener.InitForMacros(m_oMacros,m_oLoadDataMgr);
		
		m_oWorkFlowMgr=new CMqWorkFlowRules(m_oViewFields,m_oLoadDataMgr, oMqAutoList, oDisplayElements);

		if (!m_oWorkFlowMgr.InitDeclaredBizRules)
		{
			m_oWorkFlowMgr.InitDeclaredBizRules=fnInitDeclaredBizRules;
		}

		m_oLoadDataMgr.SetOnBeforeLoad(
			"m_objWorkFlow.Initialize(m_objViewFields,m_objLoadDataMgr.GetDataHTMLDocument(),m_MqAutoList, m_objDisplayElements);" + 
			"objCustomCode.AddWorkflowRules(m_objWorkFlow,m_objViewFields,m_objLoadDataMgr.GetDataHTMLDocument(), m_MqAutoList, m_objDisplayElements);" +
			"objCustomCode.OnBeforeLoadRec();" + 
			" return true;",false);

		m_oLoadDataMgr.SetOnAfterLoad(
			"ShowDefaultControls();" +
			"m_objWorkFlow.OnLoad();" +
			"objCustomCode.OnAfterLoadRec();" +
			"m_objLoadDataViewActions.Reset(); " +
			"var objFieldsDescription = new FieldsDescription();" +
			"objFieldsDescription.AttachToAllFields(); " +
			"objFieldsDescription.ShowFieldHeader();" +
			" return true;",false); 

		m_oRecMgr=new CMqRecordMgr(m_oLoadDataMgr, m_oHTTPRequest);
		
		m_oRecMgr.SetVecWebSession(this);
		
		// ToDo: move to UI Init.
		if(typeof(ShowBannerPopup)!="undefined"){
		ShowBannerPopup(false);
	}
	}

		
	function LoadDataMgr()
	{
		return m_oLoadDataMgr;
	}
			
	function ViewFields()
	{
		return m_oViewFields;
	}
	
	function WorkflowMgr()
	{
		return m_oWorkFlowMgr;
	}
	
	function URL()
	{
		return m_oWebSessURL;
	}

	function RecordMgr()
	{
		return m_oRecMgr;
	}
	
	function SummaryList()
	{
		return m_objSL;
	}	

	function ReportMgr()
	{
		return m_objReportMgr;
	}

	function HTTPRequest()
	{
		return m_oHTTPRequest;
	}
	
	function MainWindow()
	{
		return m_oVNMainWin;
	}

	function CommandBar()
	{
		return m_objCmdBar;
	}

	function ViewFeatures()
	{
		return _viewFeatures;
	}
	
	
	function AddFeature(feature)
	{
		if(feature != undefined)
		{
			this.m_VNFeatures.push(feature);
		}
	}
	
	function FeatureExists(iID)
	{
		if( this.m_VNFeatures.filter(function(x){if(x.ID == iID){return x}}).length > 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}	
	
	function AddSetting(setting)
	{
		if(setting != undefined)
		{
			if(_me.m_VNSettings == undefined)
			{
				_me.m_VNSettings = new Array();
			}

			if(!SettingExists(setting.ID))
			{
				_me.m_VNSettings.push(setting);
			}
		}
	}
	
	function SettingExists(iID)
	{
		if(_me.m_VNSettings.filter(function(x){if(x.ID == iID){return x}}).length > 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	function GetSettingValue(iID)
	{
		var settingValue = "";
		if(_me.m_VNSettings != undefined)
		{
			var settings = _me.m_VNSettings.filter(function(x){if(x.ID == iID){return x}});
			if(settings != undefined)
			{
				if(settings.length > 0)
				{
					settingValue=settings[0].Value;
				}
			}	
		}
		return settingValue;
	}	
	
	function ViewName()
	{
		//this is the project_view name together
		if (!m_sViewName)
		{
			m_sViewName=g_VWS.MainWindow().ViewFolderURL();
			try{
				m_sViewName=g_MqRef.MqStr.StripTrailing(m_sViewName, "/");
				m_sViewName= m_sViewName.split("/").pop();
			} catch(e){};
		}
		return m_sViewName;
	}
	
	function AdminMode()
	{
		return m_blnAdminMode;
	}
	
	function SetAdminMode(blnAdminMode)
	{
		m_blnAdminMode=blnAdminMode;
		
		m_objSL.HandleAdminModeUI();
	}
	
	function Queries()
	{
		return m_VNQueries;
	}
	
	/// Determine if the resources (global and view) have been loaded and load them if they have not 
	/// mqRef is the g_MqRef of the local htm doc of the caller. 
	function LoadRes(mqRef)
	{
		var RES_VIEW_RESOURCES_LOADED="Loaded2";
		var bViewResLoaded=false;
		
		if (mqRef)
		{
			if (mqRef.RESX)
			{
				bViewResLoaded= (mqRef.RESX[RES_VIEW_RESOURCES_LOADED]== "1");
			}
				
			if (!bViewResLoaded)
			{
				if (_me.MainWindow)
				{
					var view=_me.ViewName();
					
					if (view)
					{
						mqRef.ResMgr.LoadViewRes(view);			

					}
				}
			}
		}
	}

	// function REST()
	// {
		// var rest= new RESTClient();
		// rest.Initialize( g_VWS.URL.BaseVDURL() );
		// return rest;
	// }
	
	this.Init=Init;
	this.InitFields=InitFields;
	this.LoadDataMgr=LoadDataMgr;
	this.ViewFields=ViewFields;
	this.WorkflowMgr=WorkflowMgr;
	this.URL=URL;
	this.RecordMgr=RecordMgr;
	this.SummaryList=SummaryList;	
	this.Macros=m_oMacros; 
	this.URIOpener=m_oURIOpener; 
	this.ReportMgr=ReportMgr;
	this.HTTPRequest=HTTPRequest;
	this.MainWindow=MainWindow;
	this.CommandBar=CommandBar;
	this.DefaultSearchField=new Object();
	this.DefaultSearchField.FieldID=0;
	this.AddFeature =AddFeature;
	this.FeatureExists = FeatureExists;	
	this.BrowserCheck = m_oBrowser;
	this.ViewName=ViewName;
	this.LoadRes=LoadRes;
	this.Features={
			FEATURE_DELETE_REC:107,
			FEATURE_MASS_UPDATE:112,
			FEATURE_ADD_ROLES_TO_CATALOG:116,
			FEATURE_ADD_ASSET_DEFINITIONS_TO_CATALOG:117,
			FEATURE_DELETE_ROLES_FROM_CATALOG:118,
			FEATURE_DELETE_ASSET_DEFINITIONS_FROM_CATALOG:119,
			FEATURE_EDIT_FROM_IN_EMAILS:121,
			FEATURE_ADD_EMPLOYEES_TO_CATALOG:122,
			FEATURE_DELETE_EMPLOYEES_FROM_CATALOG:123,
			FEATURE_ATTACH_UPLOAD_FILES:126,
			FEATURE_ATTACH_LINK_FILES:127,
			FEATURE_ATTACH_LINK_ALFRESCO:128,
			FEATURE_ATTACH_LINK_SP:130,
			FEATURE_IMPORT_GSUITE:134,
			FEATURE_ASSETS_REASSIGN:142,
			FEATURE_ASSETS_SCRAP:143,
			FEATURE_ASSETS_MARK_LOST:144,
			FEATURE_ASSETS_REQUEST_STATUS:145,
			FEATURE_BARCODE_SCAN:150,
			FEATURE_ENABLE_DEVICES:152,
			FEATURE_DISABLE_DEVICES:153,
			FEATURE_DEPROVISION_DEVICES:154,
			FEATURE_POWERWASH_DEVICES:155,
			FEATURE_CONFIRM_ACCEPTANCE:159
			};
	this.ContactSecurityType=2;
	this.AddSetting=AddSetting;
	this.GetSettingValue=GetSettingValue;
	this.WebViews={
			MANAGE_ASSET_TYPES:20,
			ASSET_LIBRARY:44,
			MANAGE_LOCATIONS:50,
			SW_ASSET_LIBRARY:82,
			MANAGE_SW_ASSET_TYPES:83,
			DEPARTMENT_ASSETS:93,
			ASSET_LIBRARY_MOBILE:94
			};
	this.AdminMode=AdminMode;
	this.SetAdminMode=SetAdminMode;
	this.Queries=Queries;

	this.Projects={
			HELPDESK:4,
			USERS:8,
			ROLES:14,
			RESOURCES:15,
			ACTIONS:16
			};
			
	this.ViewFeatures=ViewFeatures;
}

function VNUser(sName, iID)
{
	// Change to Get/Set when needed 
	this.Name=sName;
	this.ID=iID;

}

function VNFeature(sName, iID)
{
	// Change to Get/Set when needed 
	this.Name=sName;
	this.ID=iID;

}


function VNMainWindow(oHTMLMainWin, oVecWS)
{
	var LOAD_REC_OVERLAY_CTNR = "loadRecOverlay";
	const DISABLE_MAIN_OVERLAY = "disableMainOverlay";

	var m_oHTMLMainWin=oHTMLMainWin;
	var m_bModal;
	var m_sBaseURL;
	var m_sViewFolderURL;
	var m_oVecWS=oVecWS;
	
	/** The BaseURL is the HTML folder of the view, which is the folder of CensusMain
	For example: http://server/connect02/example_view/html/
	**/
	
	function BaseURL()
	{
		if (!m_sBaseURL)
		{
			m_sBaseURL=g_MqRef.MqFS.GetCurrentLocation(m_oHTMLMainWin);
		}	
		return m_sBaseURL;		
	}

	/** The ViewFolderURL is the folder of the view, which is usually named <project>_<view name>
	For example: http://server/connect02/example_view/
	**/
	
	function ViewFolderURL()
	{
		if (!m_sViewFolderURL)
		{
			m_sViewFolderURL=g_MqRef.MqFS.ViewFolderURL(m_oHTMLMainWin);
		}	
		return m_sViewFolderURL;		

	}
	
	function Close()
	{
		if (this.IsModal())
		{
			m_oHTMLMainWin.CloseModalWindow();
		}else{
			m_oHTMLMainWin.close();
		}
	}

	// Check if the current Web view is Modal or a separate window that can/should be closed.
	function IsModal()
	{

		// Get it once
		if (typeof(m_bModal)=="undefined"){

			var retModal=true;
			if (m_oHTMLMainWin)
			{
				if (m_oHTMLMainWin.location)
				{
					// if the top URL is not the Main window for the current view, then it's modal
					retModal=(m_oHTMLMainWin.location.href!==top.location.href);
				}
			}
			m_bModal=retModal;
		}
		
		return m_bModal;
	}
	
	function SetFocus(sFrameName, sElementID)
	{
		try
		{
			if (m_oHTMLMainWin)
			{
				var frm=m_oHTMLMainWin.document.getElementById(sFrameName);
				
				if (frm)
				{
					frm.contentWindow.focus();
					var oElem=frm.contentDocument.getElementById(sElementID);
					if (oElem)
					{	
						oElem.value="";
						oElem.focus();

					}

				}
			}
		
		}catch(e){}
	}
	
	function OnLoad()
	{
		try
		{
			if (m_oVecWS.SummaryList())
			{
				var oSLSearch=m_oVecWS.SummaryList().SLSearch();
				if (oSLSearch.FocusOnLoad)
				{
					oSLSearch.SetFocus();
				}
			}
			
		}catch(e){}
	}
	
	function ShowBusy(blnVisible, blnForceToFront)
	{
		var objLoadRecOverlay=m_oHTMLMainWin.document.getElementById(LOAD_REC_OVERLAY_CTNR);
		if(objLoadRecOverlay){
			if(blnForceToFront){
				objLoadRecOverlay.style.zIndex=9999;
			}else{
				objLoadRecOverlay.style.zIndex=1001;
			}
			if(blnVisible){
				objLoadRecOverlay.style.display="";
			}else{
				objLoadRecOverlay.style.display="none";
				
			}
		}
	}
	
	function ShowDisableMain(blnVisible, blnForceToFront)
	{
		var objDisableMainOverlay = m_oHTMLMainWin.document.getElementById(DISABLE_MAIN_OVERLAY);
		if(objDisableMainOverlay)
		{
			if(blnForceToFront){
				objDisableMainOverlay.style.zIndex=9999;
			}else{
				objDisableMainOverlay.style.zIndex=1001;
			}
			if(blnVisible){
				objDisableMainOverlay.style.display="";
			}else{
				objDisableMainOverlay.style.display="none";
			}
		}
	}
	
	function GetDocument()
	{
		return m_oHTMLMainWin.document;
	}
		
	this.HTMLMainWin=m_oHTMLMainWin;
	this.IsModal=IsModal;
	this.Close=Close;
	this.SetFocus=SetFocus;
	this.BaseURL=BaseURL;
	this.ViewFolderURL=ViewFolderURL;	
	this.OnLoad=OnLoad;
	this.ShowBusy=ShowBusy;
	this.ShowDisableMain=ShowDisableMain;
	this.GetDocument=GetDocument;
}

// ----- MqWebSessionURL.js

function CMqWebSessionURL()
{
	var m_strCurrentVDName="";
	var m_strBaseVDName="";
	var _strBaseVDURL="";
	
	function Init(strCurrentVDName, strBaseVDName)
	{
		m_strCurrentVDName=strCurrentVDName;
		m_strBaseVDName=strBaseVDName;
		_strBaseVDURL = location.protocol + "//" + location.hostname + "/" + m_strBaseVDName;
	}
	
	function CurrentVDName()
	{
		return m_strCurrentVDName;
	}

	function BaseVDName()
	{
		return m_strBaseVDName;
	}

	function BaseVDURL()
	{
		return _strBaseVDURL;
	}
	
	function GetLink(recID)
	{
		return GetViewLink(g_VWS.ProjectID, g_VWS.ViewShortName, recID);
	}
	
	function GetViewLink(projID, viewName, recID)
	{
		var strLink=_strBaseVDURL + "/vz/" + projID + "/" + g_MqRef.MqStr.MqEncodeURIComponent(viewName);
		
		if(recID){
			strLink+="/" + recID;
		}
		return strLink;
	}

	this.Init=Init;
	this.CurrentVDName=CurrentVDName;
	this.BaseVDName=BaseVDName;
	this.BaseVDURL=BaseVDURL;
	this.GetLink=GetLink;
	this.GetViewLink=GetViewLink;
}


function WebViewOpener(oWebSessURL, objRequest)
{
	var m_oWebSessURL=oWebSessURL;
	var m_objRequest=objRequest;
	
	function Open(strView, bModal, iRecID) 
	{
		var strURL=GetNewVDURL("View=" + g_MqRef.MqStr.MqEncodeURIComponent(strView) + 
				"&UEID=" + g_MqRef.MqStr.MqEncodeURIComponent(iRecID) );
		// Temp workaround. 
		strURL=strURL.replace("redirect=1","redirect=0");
		
		var oWebViewWin=new VNWindow(bModal);
		
		WriteConsole("[WebViewOpener.Open] Opening view:" + strView + " and loading record:" + iRecID + " using URL:" + strURL);
		oWebViewWin.Open(strURL, strView + iRecID );
	}
	
	function GetNewVDURL(strAddRedirQS)
	{
		var co = m_objRequest.Get("wcProdInv.asp?WCI=wciGetDiffVDURL&Base=" + m_oWebSessURL.BaseVDName() + 
			"&AddQS=" + g_MqRef.MqStr.MqEncodeURIComponent(strAddRedirQS));
		if (co!=m_objRequest.CANCEL_PROCESS)
		{
			var objResponse=m_objRequest.Response(co);
										
			if (objResponse){
				if (objResponse.HasErrors())
				{
					objResponse.ProcessErrors("",true,window);
				}else
				{
					return co;
				}
			}
		}
					
		return true;
	}
	
	this.Open=Open;
	
}

function SearchField(sElemID, iMin, searchFunc, htmlDoc)
{
    if (!htmlDoc) {
        htmlDoc = document;
    }
    const _htmlDoc = htmlDoc;
    const _searchInput = _htmlDoc.getElementById(sElemID);
    
		if (_searchInput)
		{
			_searchInput.oninput=OnInput;
		}
		const SEARCH_DEF_MSG="Search";
		const MIN_CHARS_FOR_SEARCH=iMin;
		
		var _strLastSearch;
		var _dtLastInputTS;
		var _me=this;

		function OnInput()
		{			
			if(_searchInput)
			{
				var strValue=_searchInput.value;
				if(strValue!=_strLastSearch)
				{
					_strLastSearch=strValue;

					if(strValue!= SEARCH_DEF_MSG && ( strValue.length >= MIN_CHARS_FOR_SEARCH) )
					{
						_dtLastInputTS=new Date();
						window.setTimeout(_me.DelayedSearch, 500);
					}
					else
					{
						if ( _me.searchFunc)
						{
							_me.searchFunc( "" );
						}
					}
				}
			}
		}
		
	function DelayedSearch()
	{
			
		if(_dtLastInputTS){
			var dtCurrent=new Date();
			if((dtCurrent.getTime()-_dtLastInputTS.getTime())>500)
			{
				if ( _searchInput && _me.searchFunc)
				{
					_me.searchFunc( _searchInput.value );
				}
			}
		}
	}
	
	this.OnInput=OnInput;
	this.DelayedSearch=DelayedSearch;
	this.searchFunc=searchFunc;
}

//////////////////////////////////////////////////////////////////////////////////
//	CMqLookupItemDDEvents Class
//	Dependencies: CMqFormElement, Window.js, CMqEventUtils
//////////////////////////////////////////////////////////////////////////////////
function CMqLookupItemDDEvents()
{
	var m_objCallerDocRef = document;
	var m_objCensusMainRef=parent;
	var ID_IFRAME_AUTO_SUGGEST = "ifrAutoSuggest";	
	var m_blnVisible=false;
	var m_strBoundControlID = "";
	var m_strOriginalText = "";
	var m_strOriginalValue = "";
	var m_strUpdateSearchRetries = 0; 
	var m_strPathToDisplayChoicesASP;
	var KEY_ENTER = 13;
	var KEY_TAB = 9;
	var KEY_SHIFT = 16;
	var KEY_BACKSPACE = 8;
	var KEY_ARROW_UP = 38;
	var KEY_ARROW_DOWN = 40;
	var KEY_ARROW_LEFT = 37;
	var KEY_ARROW_RIGHT = 39;
	
	var ATTRIBUTE_MQVALUE = "mqvalue";
	var ATTRIBUTE_ALLOW_NOT_IN_LIST = "mqallownotinlist";
	var ATTRIBUTE_AUTOSUGGESTOFF = "mqautosuggestoff";
	var VALUE_INVALID_MQVALUE = "";
	var NUM_MAX_RESULTS_PER_PAGE = 25;
	var MAXIMUM_MS_TO_WAIT_FOR_UPDATE = 5000;
	var RETRY_DELAY_UPDATE_SEARCH = 25;
	var CSS_UNIT_PIXELS = "px";
	var m_objEventUtils = new CMqEventUtils();
	
	//Used when repositioning/sizing the frame:
	var BOUND_CONTROL_BORDER_SIZE = 1;
	var BOUND_CONTROL_SIZE = 25; //includes padding
	var AUTOSUGGEST_WIDTH_MAX = 400;
	var AUTOSUGGEST_HEIGHT_MAX = 170;
	
		
	//AUTOSUGGEST EVENTS - START/////////////////////////////////////////////////////////////////////////////////////
	function OnBlur(objElement){

		WriteConsole("[LookupItemDropDown.OnBlur] Bound control '" + objElement.id + "' and value '" + objElement.value + "'");
		
		if(objElement){
			if(!ElementIsReadOnly(objElement)){
				if(!IsVisible()){
					WriteConsole("[LookupItemDropDown.OnBlur] Validating...");
					ValidateBoundControlValue(true);
				}
			}
		}
	}
	
	function OnFocus(objElement, strFieldID, strCaption, e){
		WriteConsole("[LookupItemDropDown.OnFocus] Bound control '" + objElement.id + "' and value '" + objElement.value + "'");
		
		var blnAbort = false;
		if(objElement){
		
			if(!ElementIsReadOnly(objElement)){
			//take note of original values.

				if(!IsVisible()){
				//Very important - only execute this logic when the dialog is loaded. Why?
				//We want to take a snapshot of the field value before it is influenced by the LookupItemDropDown dialog.
				
					if(objElement.getAttribute(ATTRIBUTE_AUTOSUGGESTOFF) != "1"){
						//Do we have a bound conrol ID?
						if(m_strBoundControlID == objElement.id){
							//After Hiding the frame, the controlID is blank.
							//If not blank, it must have been set to something.
							//Don't do anything - we already have the info we need.
							blnAbort = true;
						}
						
						if(!blnAbort){
							
							//We weren't told to abort - that means the bound control we know about is different
							//from the one were' focusing on now.
							//Is current one valid? (should be)
							if(m_strBoundControlID != ""){
								
								//Restore original values if needed - we need to clean up before we use the new focused control.
								ValidateBoundControlValue();
							}
							
							//Now that the other control has been concluded...
							//Take note of the values.
							m_strBoundControlID = objElement.id;	
							m_strOriginalValue = objElement.getAttribute(ATTRIBUTE_MQVALUE);
							m_strOriginalText = objElement.value;
							
							WriteConsole("[LookupItemDropDown.OnFocus] Bound control '" + objElement.id + "' with value '" + objElement.value + "' and mqvalue '" + m_strOriginalValue + "'");
							

							
							//Focus and select the text.
							//We figure users will typically want to replace their selection
							// - rather than alter it by a few characters.
							// -- No longer the case, now appears either way.
							objElement.focus();
							objElement.select();
                               
							WriteConsole("[LookupItemDropDown.OnFocus] Showing auto suggest frame...");
							Show(objElement, strFieldID, e);

							WriteConsole("[LookupItemDropDown.OnFocus] Waiting to update the frame with the search value '" + objElement.value + "'");
							UpdateSearchWhenReady(e, objElement, true);
						}
					}
						
				}else{
					//The AutoSuggest dialog is visible, and we received another focus event?
					//Make sure the focus event came from the bound control.
					WriteConsole("[LookupItemDropDown.OnFocus] Checking to see if I should hide the suggest frame");
					
					if(!ElementMatchesBoundControl(objElement)){
						//Not the same ID? They somehow focused on another control.
						//Nice try! Hide the auto complete frame.
						Hide(false, "LookupItemDD.OnFocus");
						
						OnFocus(objElement, strFieldID, strCaption, e);
					}
				}
			}
		}
	}
	
	//Called whenenever the bound control receives an "onkeyup" event
	function OnKeyUp(objElement, strFieldID, strCaption, event){

		WriteConsole("[LookupItemDropDown.OnKeyUp] Bound control '" + objElement.id + "' and value '" + objElement.value + "'");
		
		if(objElement){
			if(!ElementIsReadOnly(objElement)){
				if(!IsVisible()){
					WriteConsole("[LookupItemDropDown.OnKeyUp] AutoSuggest frame isn't visible and loaded yet.");
					WriteConsole("[LookupItemDropDown.OnKeyUp] Is search value '" + objElement.value + "' >= 1 character?");
					
					if(objElement.value.length >= 0){
					
						if(m_objEventUtils){
							var keynum = m_objEventUtils.GetKeyCode(event);
							if(keynum!=KEY_TAB && keynum!=KEY_SHIFT){ //don't trigger the search when tabbing in if there 
								WriteConsole("[LookupItemDropDown.OnKeyUp] Yes... Showing auto suggest frame...");
								Show(objElement, strFieldID, event);
								
								WriteConsole("[LookupItemDropDown.OnKeyUp] Waiting to update the frame with the search value '" + objElement.value + "'");
								UpdateSearchWhenReady(event, objElement, false);
							}else{
								WriteConsole("[LookupItemDropDown.OnKeyUp] Not searching because was tabbed into and there is a value in the field");
							}
						}
					}
				
				}else{
					WriteConsole("[LookupItemDropDown.OnKeyUp] Autosuggest frame is already visible and loaded.");
					WriteConsole("[LookupItemDropDown.OnKeyUp] Waiting to update the frame with the search value '" + objElement.value + "'");
					UpdateSearchWhenReady(event, objElement, false);
				}
			}
		}
	}

	//called whenenever the bound control receives an "onkeydown" event
	function OnKeyDown(objElement, event)
	{
		if(objElement){
			if(!ElementIsReadOnly(objElement)){
				
				//Trigger a focus event. 
				OnFocus(objElement);
			
				WriteConsole("[LookupItemDropDown.OnKeyDown] Bound control '" + objElement.id + "' and value '" + objElement.value + "'");
				if(IsVisible()){
					HandleSpecialKeys(objElement, event);	
				}
			}
		}
	}
	
	function OnClick(objElement, e){
		if(objElement){
			if(ElementMatchesBoundControl(objElement)){
				if(!ElementIsReadOnly(objElement)){
					//Cancel the event here, or it will bubble up and trigger an Record body onclick, which will
					//hide the AutoSuggest frame.
					if(m_objEventUtils){
						m_objEventUtils.CancelEventBubble(e, true);
					}
				}
			}
		}
	}
	
	
	//AUTOSUGGEST EVENTS - END/////////////////////////////////////////////////////////////////////////////////////	
	
	
	//AUTOSUGGEST ACTIONS - START//////////////////////////////////////////////////////////////////////////////////
	function Initialize(strPathToDisplayChoices, objCallerDocRef, arrHideEventElements, objCensusMainRef)
	{
		m_strPathToDisplayChoicesASP = strPathToDisplayChoices;
		m_objCallerDocRef = objCallerDocRef;
		m_objCensusMainRef=objCensusMainRef;
		
		if(arrHideEventElements){
			RegisterHideEvents(arrHideEventElements);
		}
	}
	
	function Show(objElement, strFieldID, event)
	{
		if(m_objEventUtils){
			var keynum = m_objEventUtils.GetKeyCode(event);
			
			if(!IsVisible() && keynum != KEY_ENTER){
				var objAutoSuggestFrame = m_objCallerDocRef.getElementById(ID_IFRAME_AUTO_SUGGEST);
				if(objAutoSuggestFrame){
				
					if(objElement){
						SetPosition(objElement);
                        
						if(objElement){							
							var strURL = m_strPathToDisplayChoicesASP + "../../VNChoices/GetValues?FID=" + strFieldID + "&Proj="+g_VWS.ProjectID;
							
							WriteConsole("[LookupItemDropDown.Show] Navigating to '" + strURL + "'");
							
							var strAutoSuggestURL = "TmplLookupItemDD.htm";
							
							var objField=m_objCensusMainRef.m_objViewFields.Field(strFieldID);
							var objCL = new CMqChoiceList(m_objCallerDocRef, m_objCensusMainRef);
							objCL.InitLargeListOrCombo(objField, "", strURL, true, NUM_MAX_RESULTS_PER_PAGE);
			
							if(objAutoSuggestFrame.contentWindow){
								if(objAutoSuggestFrame.contentWindow.window){
									if(objAutoSuggestFrame.contentWindow.window.location){
										//in case the old auto suggest was used, update the frame source
										if(objAutoSuggestFrame.contentWindow.window.location.href.indexOf(strAutoSuggestURL) < 0)
										{
											objAutoSuggestFrame.contentWindow.window.location.replace("../HTML/" + strAutoSuggestURL + "?MqFID=" + strFieldID);
										}
									}
								}
								if(m_objLookupItemQry)
								{
									m_objLookupItemQry.ClearStartSearchDate();
								}
								
								if(objAutoSuggestFrame.contentWindow.LoadList)
								{
									objAutoSuggestFrame.contentWindow.LoadList(strFieldID);
								}
								
								m_objLookupItemDD.Display();
							}
						}
					}
				}
			}
		}
	}
	
	//Triggered when the Record body fires an onresize event.
	function Reposition()
	{
		if(IsVisible()){
			var objBoundControl = m_objCallerDocRef.getElementById(m_strBoundControlID);
			
			if(objBoundControl){
				SetPosition(objBoundControl);
			}
		}
	}
	
	function SetPosition(objBoundControl)
	{
		var objAutoSuggestFrame = m_objCallerDocRef.getElementById(ID_IFRAME_AUTO_SUGGEST);	
		
		if(objAutoSuggestFrame){
		
			var objFormElement = new CMqFormElement();	
			
			if(objBoundControl){
				var lngXPos = objFormElement.GetPosition(objBoundControl, true);
				var lngYPos = objFormElement.GetPosition(objBoundControl, false);
				var lngWidthWithIFrame = (lngXPos + AUTOSUGGEST_WIDTH_MAX);
				
				//Determine if the iframe will go beyond the X contraints:
				if(lngWidthWithIFrame > GetWinWidth()){
					lngXPos = lngXPos - (AUTOSUGGEST_WIDTH_MAX-objBoundControl.offsetWidth+BOUND_CONTROL_BORDER_SIZE);
				}else{
					objAutoSuggestFrame.style.width = AUTOSUGGEST_WIDTH_MAX + CSS_UNIT_PIXELS;
					objAutoSuggestFrame.style.height = AUTOSUGGEST_HEIGHT_MAX + CSS_UNIT_PIXELS;
				}
				objAutoSuggestFrame.style.top = (lngYPos + (BOUND_CONTROL_SIZE + (BOUND_CONTROL_BORDER_SIZE*2))) + CSS_UNIT_PIXELS;
				objAutoSuggestFrame.style.left = lngXPos + CSS_UNIT_PIXELS;
			}
		}	
	}
	

	function UpdateSearchWhenReady(e, objElement, bOnFocus)
	{

		try{
			//If UpdateSearchWhenReady is called via the setTimeout below, the "event" parameter is lost. IE seems to be losing
			//the "event" object as it was when this process originated. To prevent this, we manually create
			//a copy of the event here. IE doesn't mess with the event this way.
			//http://javascriptfixer.com/member-not-found.php
			if(m_strUpdateSearchRetries == 0){
				var eCopy = {};
				for (var i in e){
					eCopy[i] = e[i];
				}			
				e = eCopy;
			}
			
		}catch(err){}//if this fails, try to continue as usual.
			
		
		var objAutoSuggestFrame = m_objCallerDocRef.getElementById(ID_IFRAME_AUTO_SUGGEST);
		
		if(objAutoSuggestFrame){
			if(objAutoSuggestFrame.contentWindow){
				objAutoSuggestFrame = objAutoSuggestFrame.contentWindow;
				
				WriteConsole("[LookupItemDropDown.UpdateSearchWhenReady] Bound control '" + objElement.id + "'");
				
				//Have we reached the maximum retries allowed?
				//2000 divided by 25 = 80 retries
				if(m_strUpdateSearchRetries < (MAXIMUM_MS_TO_WAIT_FOR_UPDATE / RETRY_DELAY_UPDATE_SEARCH)){

					//Make sure the grid is fully loaded before we update the search value.
					if(!objAutoSuggestFrame.UpdateSearch || !IsVisible()){
						WriteConsole("[LookupItemDropDown.UpdateSearchWhenReady] Waiting... " + m_strUpdateSearchRetries + ";IsVisible=" + IsVisible());
						
						if(!objAutoSuggestFrame.UpdateSearch)
							WriteConsole("[LookupItemDropDown.UpdateSearchWhenReady] Reason: UpdateSearch wasn't there.");
							
						if(!IsVisible())
							WriteConsole("[LookupItemDropDown.UpdateSearchWhenReady] Reason: AutoSuggest was not visible.");
						
						m_strUpdateSearchRetries = m_strUpdateSearchRetries + 1;
						
						setTimeout(function() {UpdateSearchWhenReady(e, objElement, bOnFocus)}, RETRY_DELAY_UPDATE_SEARCH);
					}else{
						WriteConsole("[LookupItemDropDown.UpdateSearchWhenReady] Ready to go! Calling AutoSuggest_UpdateSearch...");
						
						m_strUpdateSearchRetries = 0;
						UpdateSearch(e, objElement, bOnFocus);
					}
				}else{
					WriteConsole("[LookupItemDropDown.UpdateSearchWhenReady] Reached maximum retries - had to abort. Retries: " +  m_strUpdateSearchRetries);
					m_strUpdateSearchRetries = 0;
					
					//Ok, the retries count was higher than the limit. Something is wrong with the AutoSuggest frame, most likely.
					//Terminate it... we may otherwise be dealing with an infinite loop.
					Hide(false, "AutoSuggest.UpdateSearchWhenReady");
				}
			}
		}
	}
	
	//As the name suggests, we use this method to determine if we should apply the best match
	//before the autosuggest frame is hidden.
	function AttemptLastMinuteMatch(blnLastMinuteMatchRequiresText)
	{
		var blnAbort = false;
		var objElement;
		
		if(IsVisible()){
			WriteConsole("[LookupItemDropDown.AttemptLastMinuteMatch] Evaluating... Match requires text? " + blnLastMinuteMatchRequiresText + " (" + typeof(blnLastMinuteMatchRequiresText)  + ")");
			var objAutoSuggestFrame = m_objCallerDocRef.getElementById(ID_IFRAME_AUTO_SUGGEST);

			if(objAutoSuggestFrame){
			
				if(blnLastMinuteMatchRequiresText){
					WriteConsole("[LookupItemDropDown.AttemptLastMinuteMatch] Making sure that the bound control has text... ");
					objElement = m_objCallerDocRef.getElementById(m_strBoundControlID);
					
					if(objElement){
						//Only restore the values if something is in the textbox.
						//Maybe they want to wipe field out - we naturally allow this.
						if(objElement.value.length <= 0){
							WriteConsole("[LookupItemDropDown.AttemptLastMinuteMatch] Bound control didn't have any text. Abort!");
							blnAbort = true;
						}else{
							WriteConsole("[LookupItemDropDown.AttemptLastMinuteMatch] Bound control had text, proceeding as usual.");
						}
					}
				}
				
				if(!blnAbort){
					//If at least one record is shown, assume they wanted to select it.
					//It is, after all, the best match according to what they were typing.
					if(m_objLookupItemQry)
					{					
						if(m_objLookupItemQry.GetTotalRecordCount() >= 1){	
						
							WriteConsole("[LookupItemDropDown.AttemptLastMinuteMatch] Selecting current value...");
							//Select this value before the frame is hidden.
							if(m_objLookupItemUI){
								m_objLookupItemUI.OnGridRowSelect(null,null,true);
							}
						}
					}
				}
			}
		}
	}
	
	function ValidateBoundControlValue()
	{
		WriteConsole("[LookupItemDropDown.ValidateBoundControlValue] Consider replacing the original value if necessary");
		
		if(m_strBoundControlID != ""){		
		
			//Consider replacing the original value if necessary...
			var objElement = m_objCallerDocRef.getElementById(m_strBoundControlID);
			
			if(objElement){
				//Is the MqValue still invalid?
				if(objElement.getAttribute(ATTRIBUTE_MQVALUE) == VALUE_INVALID_MQVALUE){
					
					//Only restore the values if something is in the textbox.
					//Maybe they want to wipe field out - we naturally allow this.
					if(objElement.value.length > 0){
						
						WriteConsole("[LookupItemDropDown.ValidateBoundControlValue] Current values:'" + objElement.value + "' and mqvalue '" + objElement.getAttribute(ATTRIBUTE_MQVALUE) + "'");						
						WriteConsole("[LookupItemDropDown.ValidateBoundControlValue] Restoring previous text:'" + m_strOriginalText + "' and value '" + m_strOriginalValue + "'");
						
						if(objElement.getAttribute(ATTRIBUTE_ALLOW_NOT_IN_LIST) != "1"){
							//It is - restore the previous value.
							objElement.value = m_strOriginalText;
							objElement.setAttribute(ATTRIBUTE_MQVALUE, m_strOriginalValue);
						}
					}
				}
			}
			
			//Wipe everything out - we have no more use for the bound control information.
			m_strOriginalText = "";
			m_strOriginalValue = "";
			m_strBoundControlID = "";
		}
	}
	
	//Called from many places.
	//For example, all frames visible in the main HelpDesk/Census interface will call this method as per their
	//onclick event being triggered. These events are registered by TmplLookupItemCompact.htm.
	function Hide(blnAttemptLastMinuteMatch, strSource, blnLastMinuteMatchRequiresText)
	{	
		var objAutoSuggestFrame = m_objCallerDocRef.getElementById(ID_IFRAME_AUTO_SUGGEST);

		if(IsVisible()){
			WriteConsole("[LookupItemDropDown.Hide] I've been ordered to terminate the auto complete frame by '" + strSource + "'. Attempt Last Minute Match? " + blnAttemptLastMinuteMatch + " (" + typeof(blnAttemptLastMinuteMatch)  + ")");

			//Because of the way we register the event listeners in TmplLookupItemCompact.htm, this method is sometimes called with
			//different parameters than we'd expect. Firefox sometimes sends in the mouse event as the first parameter, for example.
			//This means blnAttemptLastMinuteMatch is a mouse event object, and since the event is a valid object, 
			//the if(blnAttemptLastMinuteMatch) call would return true, attempting a last minute match in a totally invalid scenario.
			//To ensure this never happens, we first ensure the variable is a boolean.
			if(typeof(blnAttemptLastMinuteMatch) == 'boolean'){
				if(blnAttemptLastMinuteMatch){
					AttemptLastMinuteMatch(blnLastMinuteMatchRequiresText);
				}
			}

			if(objAutoSuggestFrame){
				objAutoSuggestFrame.style.display = "none";
				SetVisibleState(false);
			}
			
			ValidateBoundControlValue();
		}else{
			WriteConsole("[LookupItemDropDown.Hide] Was already hidden, no work done.");
            objAutoSuggestFrame.style.display = "block";
            objAutoSuggestFrame.style.visibility = "hidden";
		}
	}

	function Display(){
		var objAutoSuggestFrame = m_objCallerDocRef.getElementById(ID_IFRAME_AUTO_SUGGEST);

		if(objAutoSuggestFrame){
			objAutoSuggestFrame.style.display = "";
			objAutoSuggestFrame.style.visibility = "visible";
			
			if(m_objLookupItemUI){
				m_objLookupItemUI.ResizeGrid();
			}
		}
	}
	
	function HandleSpecialKeys(objElement, e)
	{
		if(m_objEventUtils){
			var keynum = m_objEventUtils.GetKeyCode(e);
			
			WriteConsole("[LookupItemDropDown.HandleSpecialKeys] key=" + keynum);
			
			switch(keynum)
			{
				case KEY_BACKSPACE: 
					WriteConsole("[LookupItemDropDown.HandleSpecialKeys] BACKSPACE");
					UpdateSearchWhenReady(e, objElement, false);
				break;
				
			  case KEY_TAB:
					WriteConsole("[LookupItemDropDown.HandleSpecialKeys] TAB");
					
					//User pressed tab. They may have a valid option selected, will check.
					//However, if the user pressed tab without having any text in the box, that should abort
					//the last minute match.
					m_objLookupItemDD.Hide(true, "LookupItemDropDown.HandleSpecialKeys - TAB", true);
				break;
				
			  case KEY_ENTER: 
					WriteConsole("[LookupItemDropDown.HandleSpecialKeys] ENTER");
					
					//User pressed Enter. They may have a valid option selected, will check.
					m_objLookupItemDD.Hide(true, "LookupItemDropDown.HandleSpecialKeys - ENTER", false);
					
					//Cancel the event here, as it has been forwarded to the auto suggest frame.
					//Without these lines, we hear 4 dings in IE.
					m_objEventUtils.CancelEventBubble(e);				
				break;

			  case KEY_ARROW_UP: 
				
				WriteConsole("[LookupItemDropDown.HandleSpecialKeys] ARROW UP");
				
				if(IsVisible()){
					if(m_objLookupItemQry){
						if(m_objLookupItemQry.GetTotalRecordCount() > 0){	
							if(m_objLookupItemUI){
								m_objLookupItemUI.SelectPreviousRow();
								//Cancel the event here, as it has been forwarded to the auto complete frame.
								//Without these lines, we hear 4 dings in IE.
								m_objEventUtils.CancelEventBubble(e);
							}
						}
					}
				}

				break;

			  case KEY_ARROW_DOWN: 
				
				WriteConsole("[LookupItemDropDown.HandleSpecialKeys] ARROW DOWN");
				
				if(IsVisible()){
			
					if(m_objLookupItemQry){
						if(m_objLookupItemQry.GetTotalRecordCount() > 0){	
							if(m_objLookupItemUI){
								m_objLookupItemUI.SelectNextRow();
								//Cancel the event here, as it has been forwarded to the auto complete frame.
								//Without these lines, we hear 4 dings in IE.
								m_objEventUtils.CancelEventBubble(e);
							}
						}
					}
					
				}
				break;
			}
		}
	}
	
	function UpdateSearch(e, objElement, bOnFocus)
	{	
		WriteConsole("[LookupItemDropDown.UpdateSearch] Start'");
		
		if(objElement){
			WriteConsole("[LookupItemDropDown.UpdateSearch] m_strBoundControlID=" + m_strBoundControlID);
			WriteConsole("[LookupItemDropDown.UpdateSearch] objElement.id=" + objElement.id);
			
			if(IsVisible() && ElementMatchesBoundControl(objElement)){
				
				var objAutoSuggestFrame = m_objCallerDocRef.getElementById(ID_IFRAME_AUTO_SUGGEST);
				
				if(objAutoSuggestFrame.contentWindow){
					objAutoSuggestFrame = objAutoSuggestFrame.contentWindow;
				}
				if(m_objEventUtils){
					var keynum = m_objEventUtils.GetKeyCode(e);

					if(objAutoSuggestFrame){
						if(keynum != KEY_ARROW_DOWN && keynum != KEY_ARROW_UP && keynum != KEY_ARROW_LEFT && keynum != KEY_ARROW_RIGHT){
							var strSearchVal = objElement.value;
						
							if(objAutoSuggestFrame.UpdateSearch){
							
								WriteConsole("[LookupItemDropDown.UpdateSearch] calling update search query with the text '" + strSearchVal + "'");
								
								objAutoSuggestFrame.UpdateSearch(e, strSearchVal, bOnFocus);

								if(m_objLookupItemQry.GetTotalRecordCount() == 0 || strSearchVal == ""){	
									SetBoundControlMqValue(VALUE_INVALID_MQVALUE);
								}
							}
						}
					}
				}
			}else{
				WriteConsole("[LookupItemDropDown.UpdateSearch] Abort - either frame wasn't loaded, or the element sent differs from the bound control. Element we received had a name of '" + objElement.id + "' and a value of '" + objElement.value + "'");
				Hide(false, "AutoSuggest.UpdateSearch");
			}
		}
	}

	function ElementMatchesBoundControl(objElement){
		var blnMatch = false;
		
		if(objElement){
			if(m_strBoundControlID == objElement.id){
				blnMatch = true;
			}
		}
		
		return blnMatch;
	}
	
	function SetBoundControlMqValue(strValue){
	
		var objElement = m_objCallerDocRef.getElementById(m_strBoundControlID);
		
		if(objElement){
			objElement.setAttribute(ATTRIBUTE_MQVALUE,strValue);
		}
	}
	
	function SetVisibleState(blnVisible){
		m_blnVisible = blnVisible;
	}
	
	function IsVisible(){
		return m_blnVisible;
	}
	
	function SetOriginalValue(strValue){
		m_strOriginalValue = strValue;
	}
	
	function SetOriginalText(strText){
		m_strOriginalText = strText;
	}
	
	function RegisterHideEvent(objFrame){
		try
		{
			var objDoc=objFrame;
			if(objFrame){
				if(objFrame.contentWindow){
					if(objFrame.contentWindow.document){
						objDoc=objFrame.contentWindow.document;	
					}
				}
			}
			
			if(objDoc){
				var objFunction;
				objFunction=function(){if(m_objLookupItemDD){m_objLookupItemDD.Hide();}};
				if(document.all){
					objDoc.attachEvent('onclick', objFunction);
				}else{
					objDoc.addEventListener('click', objFunction, false);
				}
			}
		}catch(e){
		}
	}
	
	function RegisterHideEvents(arrHideEventElements)
	{
		var ID_TABS = "Tabs";
		var objElementTemp;
		var strExternalCall;
		var objTabManager;
		var intTotalTabs;
		var objTab;

		if(arrHideEventElements){
			for(var i=0;i<arrHideEventElements.length;i++){
				objElementTemp = arrHideEventElements[i];
				
				if(objElementTemp){
					RegisterHideEvent(objElementTemp);
					
					//This next part is very specific and should eventually be more generic.
					//Rather be specific than make assumptions, at this point in the code.
					if(objElementTemp.id == ID_TABS){
						strExternalCall = "if(document){";
						strExternalCall += "if(document.getElementById('Record')){";
						strExternalCall += "if(document.getElementById('Record').contentWindow){";
						strExternalCall += "if(document.getElementById('Record').contentWindow.LookupItemDD_Hide){";
						strExternalCall += "document.getElementById('Record').contentWindow.LookupItemDD_Hide();";
						strExternalCall += "}}}};";	

						if(objElementTemp){
							if(objElementTemp.contentWindow){
								if(objElementTemp.contentWindow.m_objTabsMgr){
									objTabManager = objElementTemp.contentWindow.m_objTabsMgr;
									intTotalTabs = objTabManager.TabCount();
									
									for(var lngCount=0; lngCount<=intTotalTabs ; lngCount++){
										objTab = objTabManager.GetTabFromID(lngCount);

										if(objTab && !objTab.Hidden){
											objTab.SetOnClick(strExternalCall);
										}
									}
								}
							}
						}
					}
				}
				
				//make sure the object handle is never allowed to live.
				objElementTemp = null;
			}
		}

	}

	function GetBoundControlID()
	{
		return m_strBoundControlID;
	}

	function GetLookupItemInfoColl()
	{
		var objLookupItemInfoColl;
		
		if(m_objCensusMainRef){
			if(m_objCensusMainRef.m_objLookupItemInfoColl){
				objLookupItemInfoColl=m_objCensusMainRef.m_objLookupItemInfoColl;
			}
		}
		return objLookupItemInfoColl;
	}

	//AUTOSUGGEST ACTIONS - END//////////////////////////////////////////////////////////////////////////////////
	
	//Events
	this.OnBlur = OnBlur;
	this.OnFocus = OnFocus;
	this.OnKeyUp = OnKeyUp;
	this.OnKeyDown = OnKeyDown;
	this.OnClick = OnClick;
	
	//Actions
	this.Initialize = Initialize;
	this.Reposition = Reposition;
	this.Hide = Hide;
	this.Display = Display;
	this.SetVisibleState = SetVisibleState;
	this.IsVisible = IsVisible;
	this.SetOriginalValue = SetOriginalValue;
	this.SetOriginalText = SetOriginalText;
	this.SetBoundControlMqValue = SetBoundControlMqValue;
	this.GetBoundControlID=GetBoundControlID;

	//Properties
	this.GetLookupItemInfoColl=GetLookupItemInfoColl;
}



//LookupItemDDUI.js
function CMqLookupItemDDUI()
{
	var m_arrChoiceListHeaders = new Array();
	var m_arrChoiceListHeaderWidths = new Array();
	
	var choiceListGrid;
	var m_lngFieldID;
	var m_dtSearchPress;
	var m_objDoc;
	var m_objWin;
	
	function InitChoicesGrid(objWin, objDoc)
	{
		m_objDoc=objDoc;
		m_objWin=objWin;
	}
	
	function LoadChoicesGrid(lngFieldID)
	{
		m_lngFieldID=lngFieldID;
		
		choiceListGrid = new m_objWin.dhtmlXGridObject('choicelist_grid');
		choiceListGrid.setImagePath("../../js/codebasegrid/imgs/");
		choiceListGrid.setHeader(GetHeaderTitles());
		choiceListGrid.setNoHeader(true);
		choiceListGrid.setInitWidthsP(GetColumnWidths());
		choiceListGrid.setColTypes(GetColumnTypes());
		choiceListGrid.setColAlign("left");
		choiceListGrid.setColSorting(GetColumnSorts());
		choiceListGrid.setSkin("dhx_skyblue");
		
		choiceListGrid.attachEvent("onRowSelect", "m_objRef.m_objLookupItemUI.OnGridRowSelect");
		
		choiceListGrid.init();
		
		m_objLookupItemQry.SetSearchVars(m_objDoc, m_objWin, choiceListGrid, lngFieldID)
		if(OnDDListFinishedLoading){
			OnDDListFinishedLoading();
		}
	}
	
	function ResizeGrid()
	{
		var objGrid=m_objDoc.getElementById("choicelist_grid");
		
		if(objGrid){
			
			var intBodyWidth;
			var intBodyHeight;
			
			if (document.all){
				intBodyWidth=m_objDoc.body.offsetWidth;
			}else{
				intBodyWidth=m_objWin.innerWidth;
			}
			if (document.all){
				if (m_objDoc.documentElement && m_objDoc.documentElement.offsetHeight){
					intBodyHeight=m_objDoc.documentElement.offsetHeight;
				}else{
					intBodyHeight=m_objDoc.body.offsetHeight;
				}
			}else{
				intBodyHeight=m_objWin.innerHeight;
			}
			objGrid.style.width=(intBodyWidth) + "px";
			objGrid.style.height=(intBodyHeight-30) + "px";	
			objGrid.style.display="";
		}
	}

	function GetHeaderTitles()
	{
		var strTitles = "";
		if(typeof(m_lngFieldID)!="undefined")
		{
			strTitles=GetHeaders(m_lngFieldID);
			if(strTitles=="")
			{
				strTitles=",Value";
			}
			return strTitles;
		}
	}
	
	function GetColumnWidths()
	{
		var strColWidths = "";
		if(typeof(m_lngFieldID)!="undefined")
		{
			strColWidths=GetColWidths(m_lngFieldID);

			if(strColWidths=="")
			{
				strColWidths=",*";
			}
			return strColWidths;
		}
	}
	
	function GetColumnTypes()
	{
		var strCols = GetHeaderTitles();
		var arrCols = strCols.split(",");
		
		for(x=0; x<arrCols.length; x++)
		{
			arrCols[x]="ro";
		}
		return arrCols.join(",");
	}
	
	function GetColumnSorts()
	{
		var strCols = GetHeaderTitles();
		var arrCols = strCols.split(",");
		
		for(x=0; x<arrCols.length; x++)
		{
			arrCols[x]="str";
		}
		return arrCols.join(",");
	}

	
	function SetHeaders(lngFieldID, strHeaders)
	{
		m_arrChoiceListHeaders[lngFieldID] = strHeaders;
	}

	function GetHeaders(lngFieldID)
	{
		var strHeaderTitles = "";
		if(m_arrChoiceListHeaders[lngFieldID])
		{
			strHeaderTitles = m_arrChoiceListHeaders[lngFieldID];
		}
		return strHeaderTitles;	
	}
	
	function SetColWidths(lngFieldID, strColWidths)
	{
		m_arrChoiceListHeaderWidths[lngFieldID] = strColWidths;
	}

	function GetColWidths(lngFieldID)
	{
		var strColWidths = "";
		if(m_arrChoiceListHeaderWidths[lngFieldID])
		{
			strColWidths = m_arrChoiceListHeaderWidths[lngFieldID];
		}
		return strColWidths;	
	}
		
	
	function OnGridRowSelect(lngRowID, lngCellID)
	{
		SetRowToControl(lngRowID, false);
		m_objLookupItemDD.Hide();
	}
	
	function SetRowToControl(lngRowID, blnKeepAutoCompleteFrameOpen)
	{
		if(choiceListGrid){
			if(lngRowID==null)
			{
				//get the selected one
				lngRowID=choiceListGrid.getSelectedRowId();
			}

			var strValue=g_MqRef.MqStr.MqEncodeURIComponent(g_MqRef.MqStr.MqHtmlDecode(choiceListGrid.cellById(lngRowID,1).getValue()));
			var strID=choiceListGrid.cellById(lngRowID,0).getValue();
			var strAddValueInternal=choiceListGrid.cellById(lngRowID,1).getValue();
			
			m_objWin.AddToList(strValue, strID, strAddValueInternal);
			m_objWin.SetListToCaller(false);
						
			if(m_objWin.OnDblClickItem){
				m_objWin.OnDblClickItem(strValue, strID, blnKeepAutoCompleteFrameOpen);
			}
		}
	}
	

	function HandlePage()
	{
		SetPageCaption();
		
		HandleButtonStates();
	}
	
	function SetPageCaption()
	{
		var objPageCaption=m_objDoc.getElementById("PageCaption");

		if (objPageCaption){
			var strPC=GetPageCaption();
			objPageCaption.innerHTML=strPC;
		}				
	}

	function GetPageCaption(strHTMLTableName){
		var strReturn;

		if (!m_lngCurrentPage && !m_lngTotalRecord){
			strReturn=g_MqRef.RESX['DISPLAY_PAGE_NO_MATCHES'];
		}else{
			strReturn=g_MqRef.MqStr.FormatString(g_MqRef.RESX['DISPLAY_PAGE_NUMBERS'], m_lngCurrentPage+";"+m_lngPageCount+";"+m_lngTotalRecord+";",";");
		}

		return strReturn;
	}

	function HandleButtonStates(lngCurrentPage, lngPageCount)
	{
		if(!lngCurrentPage){
			lngCurrentPage = m_lngCurrentPage;
		}
		
		if(!lngPageCount){
			lngPageCount = m_lngPageCount;
		}

		if (lngCurrentPage==1){ 
			m_objWin.m_objMqButton.DisableButton("FirstPage");	
			m_objWin.m_objMqButton.DisableButton("PreviousPage");	
		}else if(lngCurrentPage <= 0){
			m_objWin.m_objMqButton.DisableButton("FirstPage");	
			m_objWin.m_objMqButton.DisableButton("NextPage");	
			m_objWin.m_objMqButton.DisableButton("PreviousPage");	
			m_objWin.m_objMqButton.DisableButton("LastPage");	
		}else{
			m_objWin.m_objMqButton.EnableButton("FirstPage");
			m_objWin.m_objMqButton.EnableButton("PreviousPage");
		}
		if (lngCurrentPage==m_lngPageCount || m_lngPageCount == 0) {
			m_objWin.m_objMqButton.DisableButton("LastPage");
			m_objWin.m_objMqButton.DisableButton("NextPage");	
		}else{
			m_objWin.m_objMqButton.EnableButton("LastPage");
			m_objWin.m_objMqButton.EnableButton("NextPage");
		}
	}
	
	function SelectPreviousRow()
	{
		if(!m_lngSelectedRow){
			m_lngSelectedRow = 0;
		}

		if((m_lngSelectedRow - 1) >= 0){
			m_lngSelectedRow = m_lngSelectedRow - 1;
			choiceListGrid.selectRow(m_lngSelectedRow);
			
			SetRowToControl(m_lngSelectedRow, true);
		}
	}
	
	function SelectNextRow()
	{
		if(!m_lngSelectedRow){
			m_lngSelectedRow = 0;
		}

		if((m_lngSelectedRow + 1) <= (choiceListGrid.getRowsNum()-1)){
			m_lngSelectedRow = m_lngSelectedRow + 1;
			choiceListGrid.selectRow(m_lngSelectedRow);
			
			SetRowToControl(m_lngSelectedRow, true);
		}
	}
	
	//Triggered when the actual DisplayChoices/DisplayUsers list has finished loading.
	function OnDDListFinishedLoading()
	{
		WriteConsole("[OnDDListFinishedLoading] Visible and Loaded!");

		if(m_objLookupItemDD){
			//Now that we know the list of options has loaded, make the frame visible.
			//m_objLookupItemDD.Display();

			m_objLookupItemDD.SetVisibleState(true);
			
			var objAutoSuggestFrame = m_objCallerDocRef.getElementById(ID_IFRAME_AUTO_SUGGEST);
			
			if(objAutoSuggestFrame){
				if(objAutoSuggestFrame.contentWindow){
					objAutoSuggestFrame = objAutoSuggestFrame.contentWindow;
					
					//Make sure the paging buttons make sense.
					if(objAutoSuggestFrame.HandleButtonStates){
						objAutoSuggestFrame.HandleButtonStates();
					}
				}
			}
		}
	}


	this.InitChoicesGrid=InitChoicesGrid;
	this.LoadChoicesGrid=LoadChoicesGrid;
	this.SetHeaders=SetHeaders;
	this.SetColWidths=SetColWidths;
	this.HandlePage=HandlePage;
	this.OnGridRowSelect=OnGridRowSelect;
	this.SelectPreviousRow=SelectPreviousRow;
	this.SelectNextRow=SelectNextRow;
	this.OnDDListFinishedLoading=OnDDListFinishedLoading;
	this.ResizeGrid=ResizeGrid;
}

//LookupItemDDQry.js
function CMqLookupItemDDQry(objCensusMainRef)
{
	var m_objCensusMainRef=parent;
	if(objCensusMainRef)
	{
		m_objCensusMainRef=objCensusMainRef;
	}
	var m_arrChoiceVals = new Array();
	var m_arrTypes = new Array();
	var m_dtSearchPress;
	var m_objSrchCtrl;
	var m_objDDDoc;
	var m_objDDWin;
	var m_choiceListGrid;
	var m_lngFieldID;
	var m_lngRecordsPerPage=25;
	var m_strLastSearch="";
	
	var DDTYPE_SS_1COL="1";
	var DDTYPE_SD_1COL="2";
	var DDTYPE_LD_1COL="3";
	var DDTYPE_LD_MCOL="4";
	
	function SetStartSearchDate()
	{
		m_dtSearchPress=new Date();
	}
	
	function ClearStartSearchDate()
	{
		m_dtSearchPress=null;
	}
	
	function SetType(lngFieldID, lngType)
	{
		m_arrTypes[lngFieldID] = lngType;
	}
	
	function GetType(lngFieldID)
	{
		var lngType = DDTYPE_LD_1COL;
		if(m_arrTypes[lngFieldID])
		{
			lngType = m_arrTypes[lngFieldID];
		}
		return lngType;			
	}
	
	function SetList(lngFieldID, strList)
	{
		var lstDetails = new CMqRegListDetails();
		lstDetails.SetListVals(strList);
		if(GetType(lngFieldID)==DDTYPE_SD_1COL)
		{
			lstDetails.SetTimeStamp();
		}
		m_arrChoiceVals[lngFieldID] = lstDetails;
	}
	
	function GetList(lngFieldID)
	{
		var strList = "";
		if(m_arrChoiceVals[lngFieldID])
		{
			strList = m_arrChoiceVals[lngFieldID].GetListVals();
		}
		return strList;			
	}
	
	function SetSearchVars(objDoc, objWin, choiceListGrid, lngFieldID)
	{
		m_objSrchCtrl=objDoc.getElementById("txtFind");
		m_objDDDoc=objDoc;
		m_objDDWin=objWin;
		m_choiceListGrid=choiceListGrid;
		m_lngFieldID=lngFieldID;
		
		var objLookupItemInfo=GetLookupItemInfo();

		if(objLookupItemInfo)
		{
			m_lngRecordsPerPage=objLookupItemInfo.RecordsPerPage;
		}
	}
	
	function SetData(strQuery)
	{
		strQuery=g_MqRef.MqStr.MqDecodeURIComponent(strQuery);
		WriteConsole("[LookupItemDDQry.SetData] strQuery=" + strQuery);
		m_choiceListGrid.clearAll();
		
		var strChoices=GetChoices(strQuery);
		WriteConsole("[LookupItemDDQry.SetData] " + strChoices);
		m_choiceListGrid.parse(strChoices, "json");

		HighlightValue(strQuery);
		
		window.setTimeout("m_objLookupItemUI.HandlePage()", 200);
		
		if(m_objLookupItemUI.OnDDListFinishedLoading){
			m_objLookupItemUI.OnDDListFinishedLoading();
			m_objDDWin.HideLoadingDiv();
		}

	}
	
	function HighlightValue(strQuery)
	{
		m_lngSelectedRow=GetMatchRow(strQuery);
		m_choiceListGrid.selectRow(m_lngSelectedRow);
	}
	
	function GetMatchRow(strQuery)
	{
		var lngRow=0;
		var lngCount=0;
		strQuery=g_MqRef.MqStr.MqHtmlEncode(strQuery, false).toUpperCase();
		m_choiceListGrid.forEachRow(function(id){
			
			if (m_choiceListGrid.cells(id,1).getValue().toUpperCase()==strQuery){
				lngRow=lngCount;
			}else{
				lngCount++;
			}				
		});

		return lngRow;
	}
	
	
	function GetChoices(search)
	{
		var strFullChoices = "";
		var strFilteredChoices = "";
		
		if(typeof(m_lngFieldID)!="undefined")
		{
			var lngType=GetType(m_lngFieldID);
			
			//see if we have it in memory
			strFullChoices=GetList(m_lngFieldID);

			if(strFullChoices==""){
				if(lngType==DDTYPE_SD_1COL || lngType == DDTYPE_SS_1COL)
				{
					var objLookupItemInfo=GetLookupItemInfo();
					var lngRPP;
					if(objLookupItemInfo)
					{
						lngRPP=objLookupItemInfo.RecordsPerPage;
						objLookupItemInfo.RecordsPerPage="";
					}
					//get the full list from the server
					strFullChoices=GetListResults("*");
					
					if(lngRPP)
					{
						objLookupItemInfo.RecordsPerPage=lngRPP;
					}
					//keep in memory for 1 minute, if there was no workflow on it
					var arrWorkflowVals=GetWorkflowVals();
					if(arrWorkflowVals.length==0){
						var objFormElement=new CMqFormElement();
						var objField=m_objCensusMainRef.m_objViewFields.Field(m_lngFieldID);
						objFormElement.Initialize(objField.GetBoundControl(),objField.GetControlType(),'document');
						var strQ3Params=objFormElement.GetAttribute("Q3Params");
						if(strQ3Params=="")
						{
							WriteConsole("[LookupItemDDQry.GetChoices] Store list " + strFullChoices + " for field " + m_lngFieldID);
							SetList(m_lngFieldID, strFullChoices);
						}
					}
				}else{
					if(lngType==DDTYPE_LD_MCOL || lngType==DDTYPE_LD_1COL)
					{
						//do the filtering on the server
						strFilteredChoices=GetListResults(search);
						m_strLastSearch=search;
						var jso=JSON.parse(strFilteredChoices);
							
						SetPagingVariables(jso.total, jso.page);
					}
				}
			}
			
			if(lngType!=DDTYPE_LD_MCOL && lngType!=DDTYPE_LD_1COL)
			{
				//apply the filter client side
				strFilteredChoices=FilterChoices(strFullChoices, search);
			}
			
			return strFilteredChoices;
		}
	}
	
	function FilterChoices(strChoices, search)
	{		
		if(strChoices!="")
		{
			search=g_MqRef.MqStr.MqHtmlEncode(search.toUpperCase(), false);
			var jso = JSON.parse(strChoices);
			var arrWorkflowVals=GetWorkflowVals();
			
			if(arrWorkflowVals.length>0)
			{
				jso=FilterValuesWithWorkflow(jso, arrWorkflowVals);
			}
			if(jso)
			{	
				if(jso.rows)
				{
					if(search!="*")
					{
						//go page by page to see if the direct value is in that set
						if(!SearchValWasEntered())
						{
							var foundIndex=0;
							//get the records on the page where there is a direct match
							for(x=0; x<jso.rows.length; x++)
							{
								if(jso.rows[x].data[1].toUpperCase()==search)
								{
									foundIndex=x+1;
									//found a match
									break;
								} 
							}
							if(foundIndex==0)
							{
								//return page 1
								foundIndex=1;
							}
							var pageNum=Math.ceil(foundIndex/m_lngRecordsPerPage);
							var jsoPage=GetRowsOnPage(jso, pageNum);
							SetPagingVariables(jso.rows.length, pageNum);
							strChoices=JSON.stringify(jsoPage);
						}else{
							var lngMax=jso.rows.length;
							for(x=0; x<lngMax; x++)
							{
								if(jso.rows[x].data.join(",").toUpperCase().indexOf(search) < 0)
								{
									jso.rows.splice(x, 1);
									lngMax--;
									x--;
								}
							}
							SetPagingVariables(jso.rows.length, 1);
							strChoices=JSON.stringify(jso);
						}
					}else{
						var pageNum=1;
						var jsoPage=GetRowsOnPage(jso, pageNum);
						SetPagingVariables(jso.rows.length, pageNum);
						strChoices=JSON.stringify(jsoPage);
					}
				}
				m_objCurrentJso=jso;
			}
		}

		return strChoices;
	}
	
	function SearchValWasEntered()
	{
		//search was typed in, so filter the list
		if(m_dtSearchPress){
			return true;
		}else{
			return false;
		}
	}
	function GetRowsOnPage(jso, pageNum)
	{
		//create a copy
		var jsoPage=JSON.parse(JSON.stringify(jso));
		
		var indexStart = (pageNum*m_lngRecordsPerPage)-m_lngRecordsPerPage;
		
		var lngMax=m_lngRecordsPerPage;
		for(x=0; x<indexStart;x++)
		{
			//remove all the rows before the page
			jsoPage.rows.splice(x, 1);
			indexStart--;
			x--;
		}
		
		var lngMax=jsoPage.rows.length;
		if(lngMax>m_lngRecordsPerPage)
		{
			for(x=m_lngRecordsPerPage; x<lngMax; x++)
			{
				//remove all the rows after the page
				jsoPage.rows.splice(x, 1);
				lngMax--;
				x--;
			}
		}
		return jsoPage;
	}
	
	function FilterValuesWithWorkflow(jso, arrWorkflowVals)
	{
		if(jso)
		{
			if(jso.rows)
			{
				//remove any values that aren't in the workflow filter
				var lngMax=jso.rows.length;
				for(x=0; x<lngMax; x++)
				{
					var id=jso.rows[x].data[0];
					if(!g_MqRef.MqArr.IsValueInArray(id,arrWorkflowVals))
					{
						//remove it if it's not a possible value
						jso.rows.splice(x, 1);
						lngMax--;
						x--;
					}
				}
			}
		}
		
		return jso;
	}
	
	function GetLookupItemInfo()
	{
		var objLookupItemInfo;
		if(m_objCensusMainRef)
		{
			if(m_objCensusMainRef)
		{
				if(m_objCensusMainRef.m_objLookupItemInfoColl)
			{
					if(m_objCensusMainRef.m_objLookupItemInfoColl[m_lngFieldID])
				{
						objLookupItemInfo=m_objCensusMainRef.m_objLookupItemInfoColl[m_lngFieldID];
					}
				}
			}
		}
		return objLookupItemInfo;
	}
	
	function GetWorkflowVals()
	{
		var arrWorkflowVals=new Array();
		var objLookupItemInfo=GetLookupItemInfo();

		if(objLookupItemInfo)
		{

			var strWorkflowVals=objLookupItemInfo.WorkflowValues;
			
			if(strWorkflowVals)
			{
				arrWorkflowVals=strWorkflowVals.split(";");
			}
		}
		
		return arrWorkflowVals;
	}
	function SetPagingVariables(lngTotalRecord, lngCurrentPage)
	{
		m_lngCurrentPage=0;
		m_lngPageCount=0;
		m_lngTotalRecord = 0;

		if(lngTotalRecord > 0)
		{
			m_lngTotalRecord=lngTotalRecord;
			m_lngPageCount=parseInt((m_lngTotalRecord-1)/m_lngRecordsPerPage) + 1;
			m_lngCurrentPage=lngCurrentPage;
		}
	}
	

	
	function GetListResults(search, lngPage)
	{
		if(m_objDDWin){
			
			//return all entries
			var lngGetDirectMatchesOnly="0";
			var blnGetAllResults=false;
			
			if(search == "*"){
				blnGetAllResults=true;
			}else{
				if(SearchValWasEntered()){
					//return only direct matches
					lngGetDirectMatchesOnly="1";
				}
			}			
			
			var strURL=m_objDDWin.GetLookupURL("", blnGetAllResults);
			
			strURL+="&DM=" + lngGetDirectMatchesOnly;
			
			if(lngPage){
				strURL+="&CP=" + lngPage;
			}

			var co = objRequest.Get(strURL);
	
			if (co!=objRequest.CANCEL_PROCESS){

				var objResponse=objRequest.Response(co);

				if (objResponse){
					if (objResponse.HasErrors()){
						objResponse.ProcessErrors("",true,window);
					}else{
						return co;
					}
				}
			}
		}
	}
	
	
	
	function CallAutoCompleteSearch(bCheckTime)
	{
		var bDoSearch=!bCheckTime;
		
		if(!bDoSearch)
		{
			
			if(m_dtSearchPress){
				var dtCurrent=new Date();
				if((dtCurrent.getTime()-m_dtSearchPress.getTime())>500){
					bDoSearch=true;
				}
			}
		}
		if(bDoSearch)
		{
			if(m_objSrchCtrl){
				if(m_objSrchCtrl.value != null){
					SetData(m_objSrchCtrl.value);
				}
			}
		}
	}
	
	
	function MoveFirst()
	{
		GoToPage(1);
	}
	function MovePrev()
	{
		GoToPage(m_lngCurrentPage-1);
	}
	function MoveNext()
	{
		GoToPage(m_lngCurrentPage+1);
	}
	function MoveLast()
	{
		GoToPage(m_lngPageCount);
	}

	function GoToPage(lngPageID)
	{
		m_choiceListGrid.clearAll();
		var strChoices="";
		var lngType=GetType(m_lngFieldID);
		
		if(lngType==DDTYPE_LD_MCOL || lngType==DDTYPE_LD_1COL)
		{
			strChoices=GetListResults(m_strLastSearch, lngPageID);
			var jso=JSON.parse(strChoices);
				
			SetPagingVariables(jso.total, jso.page);
			
		}else{
			if(m_objCurrentJso)
			{
				var jsoPage=GetRowsOnPage(m_objCurrentJso, lngPageID);
				SetPagingVariables(m_objCurrentJso.rows.length, lngPageID);
				var strChoices=JSON.stringify(jsoPage);
			}
		}
		m_choiceListGrid.parse(strChoices, "json");

		window.setTimeout("m_objLookupItemUI.HandlePage()", 200);
	}

	function GetTotalRecordCount()
	{
		return m_lngTotalRecord;
	}

	function GetChoiceName(lngFieldID, lngChoiceID)
	{
		var strChoiceName;
		var strFullChoices=GetList(lngFieldID);

		if(strFullChoices!=""){
			var jso = JSON.parse(strFullChoices);
			if(jso)
			{
				//see if the ID is in there, and if so return the name
				for(x=0; x<jso.rows.length; x++)
				{
					if(jso.rows[x].data[0]==lngChoiceID)
					{
						//found a match
						strChoiceName=g_MqRef.MqStr.MqHtmlDecode(jso.rows[x].data[1]);
						break;
					} 
				}
			}
		}
		
		return strChoiceName;
	}
	this.SetType=SetType;
	this.GetType=GetType;
	this.SetList=SetList;
	this.GetList=GetList;
	this.SetData=SetData;
	this.SetSearchVars=SetSearchVars;
	this.SetStartSearchDate=SetStartSearchDate;
	this.ClearStartSearchDate=ClearStartSearchDate;
	this.CallAutoCompleteSearch=CallAutoCompleteSearch;
	this.MoveFirst=MoveFirst;
	this.MovePrev=MovePrev;
	this.MoveNext=MoveNext;
	this.MoveLast=MoveLast;
	this.GetTotalRecordCount=GetTotalRecordCount;
	this.GetChoiceName=GetChoiceName;
}

function CMqRegListDetails()
{
	var m_strListVals="";
	var m_dtTS=null;
	
	function SetListVals(strListVals)
	{
		m_strListVals=strListVals;
	}
	
	function SetTimeStamp()
	{
		m_dtTS=new Date();
	}
	
	function GetListVals()
	{
		if(m_dtTS!=null)
		{
			var dtCurrent=new Date();
			if((dtCurrent.getTime()-m_dtTS.getTime())>60000){
				m_strListVals="";
				m_dtTS=null;
			}
		}
		return m_strListVals;
	}
	this.SetListVals=SetListVals;
	this.SetTimeStamp=SetTimeStamp;
	this.GetListVals=GetListVals;
}

function CMqChoiceList(objRecordDoc, objRoot)
{
	var m_objRecordDoc=objRecordDoc;
	var m_objRoot=objRoot;//censusmain
	
	function InitLargeListOrCombo(objField, fnSetValue, strSearchResultsURL, blnAutoComplete, lngRecordsPerPage)
	{
		if (objField){

			var arrSelectedIDs;
			var arrSelectedValues;
			var blnMultiSelect=objField.IsMultiSelect(m_objRecordDoc);

			if(!fnSetValue){
				fnSetValue=SetComboOrListValue;
			}

			var strWorkflowValues="";
			var objHTMLElement;
			var strQ3ParamFields="";
			var strQ3ParamValues="";

			var objFormElement=new CMqFormElement();
			objFormElement.Initialize(objField.GetBoundControl(),objField.GetControlType(),'document');
			var lngControlType=objFormElement.GetControlType();

			if(lngControlType==CTRL_TYPE_LARGE_COMBO){
				arrSelectedIDs=Array(objFormElement.GetValue());
			}else{  
				if(lngControlType==CTRL_TYPE_TEXT){
					arrSelectedValues=Array(objFormElement.GetValue());
				}else{  // CTRL_TYPE_LARGE_LIST
					var strValue = objFormElement.GetValue();
					if (strValue && strValue.length > 0)
					{
						var varValues=strValue.split(DEFAULT_VALUE_DELIM);
						if (varValues.length > 0){
							arrSelectedValues = new Array();
						}
						for(var lngIndex=0;lngIndex<varValues.length;lngIndex++)
						{
							arrSelectedValues[lngIndex]=varValues[lngIndex];
						}
					}
				}
			}
			strQ3Params=objFormElement.GetAttribute("Q3Params");
			
			if(strQ3Params!="")
			{
				//get the param values as they currently are before opening the list
				var IDX_GRP_ID=0;
				var IDX_FLD_IDS=1;
				
				var arrQ3Params=strQ3Params.split("=");
				if(arrQ3Params.length>=IDX_FLD_IDS)
				{
					var strQ3ParamFields = arrQ3Params[IDX_FLD_IDS];
					if(strQ3ParamFields!="")
					{
						var arrQ3ParamFields=strQ3ParamFields.split(";");
						for(x=0; x<arrQ3ParamFields.length; x++)
						{
							strQ3ParamValues+=g_VWS.RecordMgr().CurrentRecord().FldVals(arrQ3ParamFields[x]).GetValue() + ";";
						}
						strQ3ParamValues=arrQ3Params[IDX_GRP_ID]+"="+g_MqRef.MqStr.StripTrailing(strQ3ParamValues, ";");
					}
				}
			}
			
			
			objHTMLElement=objFormElement.GetElement();
			if(objHTMLElement){
				strWorkflowValues=objHTMLElement.getAttribute("MqWrkFlwVals")
			}

			m_objRoot.InitLookupItemVals(objField.GetID(), arrSelectedIDs, arrSelectedValues, fnSetValue, blnMultiSelect, objField.GetCaption(), 
										strWorkflowValues, strSearchResultsURL, blnAutoComplete, lngRecordsPerPage, null, null, 
										objHTMLElement, null, null, strQ3ParamValues);
		}
	}
	
	this.InitLargeListOrCombo=InitLargeListOrCombo;
}

/*
CMqRecord.js
*/

// Dependencies
// 		window.js
// 		VNWindow
//		CMqURIUtils
// 		MqWebSessionURL

//--------------------------------------------------------------------------------------------------------------
//
// Parameters
// 	objMainDocRef: reference to censusmain (main doc with constants.js, etc. referenced.
// 	objControlsSs:	reference to a MqControlsServerSide object
// 	objFrames: reference to a MqFrames object
// 	objLoadDataMgr:  reference to a CMqLoadDataMgr object
//
//--------------------------------------------------------------------------------------------------------------

function CMqRecord(objMainDocRef, objControlsSs, objFrames, objLoadDataMgr){
	
	var _me=this;
	var m_objRecordId;
	var m_objRecordDisplay;
	var m_objFormElement=new objMainDocRef.CMqFormElement();
	
	var m_objMainDocRef=objMainDocRef; // e.g. CensusMain
	var m_objControlsSs=objControlsSs;
	var m_objFrames=objFrames;
	var m_objLoadDataMgr=objLoadDataMgr;
	var m_oTabs=new VNTabs();
	var MAIN_RECFORM_BASEURL="wcRecord.asp?";
	
	var LOAD_REC_CTNR="loadRec";
	var LOAD_REC_OVERLAY_CTNR = "loadRecOverlay";
	
	var m_defScale;
	
	function Initialize(oCtrlRecordID,oCtrlRecordDisplay)
	{			
		m_objRecordId=oCtrlRecordID;
		m_objRecordDisplay=oCtrlRecordDisplay;
	}
	
	function SetRecordId(lngRecordId, skipSettingCurrentRecord)
	{		
		if ((m_objRecordDisplay) && (m_objRecordId)){
			if (lngRecordId=="") {
				lngRecordId=m_objMainDocRef.NO_CURRENT_RECORD;
			}
			m_objRecordId.value=lngRecordId;
			// Sync with the current record (skip when called from a current Record)
			if (!skipSettingCurrentRecord)
			{
				g_VWS.RecordMgr().CurrentRecord().SetRecID(lngRecordId);
			}
			if (lngRecordId>0) {
				m_objRecordDisplay.value=lngRecordId;
			}else{
				m_objRecordDisplay.value="";
			}
		}	
	}
	
	function GetRecordId()
	{		
		return _me._GetRecordId(m_objMainDocRef, m_objRecordDisplay, m_objRecordId);
	}
		
	function GetVisibleRecordId()
	{
		if ((m_objRecordDisplay) && (m_objRecordId)){
			return Number(m_objRecordDisplay.value);
		}else{
			return m_objMainDocRef.NO_CURRENT_RECORD;		
		}
	}
		
	
	function DisableRecord(blnDisable)
	{		
	}

	function SynchronizeWithIntern()
	{
		var varRecordId;
		//get internally record ID
		varRecordId=this.GetRecordId();
		//set the internal record ID to the visible one
		this.SetRecordId(varRecordId);
		
	}
	function SynchronizeWithVisible()
	{
		var varRecordId;
		//get the visisible record ID
		varRecordId=this.GetVisibleRecordId();
		//set the visble record ID to the internal one
		this.SetRecordId(varRecordId);
	}
	
	function Resize()
	{
		var objLoadRec=objMainDocRef.document.getElementById(LOAD_REC_CTNR);
		if(objLoadRec){
			if(objLoadRec.style.display===""){
				_me.Show();
			}
		}
	}
	
	function OnBeforeLoad( iRecordID, bNew)
	{
		try
		{
			g_VWS.MainWindow().ShowBusy(true);
			
			const cmdBar=g_VWS.CommandBar();
			if ( cmdBar && cmdBar.OnBeforeLoad )
			{
				cmdBar.OnBeforeLoad(iRecordID, bNew);
			}
		}catch(e)
		{ console.log(e);}
	}
	
	function OnAfterLoad()
	{
		_WriteTitleInfo(m_objMainDocRef, m_objControlsSs, m_objRecordDisplay, m_objRecordId);
		
		g_VWS.MainWindow().ShowBusy(false);
		
	}
	
	function ResolveMobileScaling(opened)
	{
		var meta = $("#metascale")
		var title = $("#titleview");
		if((meta.attr("content") == "width=device-width, initial-scale=0" || 
		meta.attr("content") == "width=device-width, initial-scale=1") &&
		title.attr("data-res") == "QUICKLINKS.CHECKIN_OUT")
		{
			if(opened)
			{
				m_defScale = meta.attr("content");
				meta.attr("content","width=device-width, initial-scale=1");
			}
			else
			{
				meta.attr("content",m_defScale);
			}
		}
	}
	
	function Show()
	{
		if(m_objMainDocRef){
			
			// LoadRec contains the Tabs + RecordForm + CommandBar + LoadData (hidden)
			var objLoadRec=m_objMainDocRef.document.getElementById(LOAD_REC_CTNR);
			
			if(objLoadRec){			
				if(!g_VWS.RecordMgr().CurrentRecord().GetIsDocked()){
					var arrWinSize=m_objMainDocRef.GetWindowSize(m_objMainDocRef.WIN_MODE_MAXIMIZED, null, null, true);
					var lngWidth=arrWinSize[0];
					var lngHeight=arrWinSize[1];
					var intBodyWidth=arrWinSize[2];
					var intBodyHeight=arrWinSize[3];
					var intBrowserWidth=arrWinSize[4];
					var intBrowserHeight=arrWinSize[5];
					var BORDER_WIDTH=4;
					var intLoadRecHeight = 100;
					var intLoadRecWidth = 100;
					var mblHeightCorrection = 50;
					
					//the new value that is being used for the left margin value (percent instead of pixels)
					var intMarginLeft = 8;

					if(CheckIfEmbedded() == true || CheckIfInSeperateWindow() == true || CMqBrowserDetector().mobile == true)
					{
						if(CMqBrowserDetector().mobile == true)
						{
							lngHeight=intBodyHeight+mblHeightCorrection;
						}else{
							lngHeight=intBodyHeight;
						}
						
						lngWidth=intBodyWidth;
						
						objLoadRec.style.width = intLoadRecWidth+ "%";
						
						objLoadRec.style.display="";
						g_VWS.MainWindow().ShowDisableMain(true);
						
					}
					else
					{
						objLoadRec.style.marginLeft = intMarginLeft + "%";
						objLoadRec.style.width = intLoadRecWidth-intMarginLeft + "%";
						
						if(g_VWS.RecordMgr().CurrentRecord().GetUseAnims() == true)
						{
							ShowAnimateRecord(true);
						}
						else
						{
							objLoadRec.style.display="";
							g_VWS.MainWindow().ShowDisableMain(true);
						}
						
					}
					objLoadRec.style.height = intLoadRecHeight + "%";
				
					_SetRecordTabHeight(lngHeight, m_objMainDocRef);
				
					g_VWS.RecordMgr().CurrentRecord().Maximize();
				}
				if(g_VWS.RecordMgr().ReloadInterval > 0)
				{
					var lngCurrentID=g_VWS.RecordMgr().CurrentRecord().GetRecID();
					window.setTimeout(function() {g_VWS.RecordMgr().CurrentRecord().Reload(lngCurrentID) }, g_VWS.RecordMgr().ReloadInterval*1000);
				}
			}
		}
	}

	function Load(iRecordID, iSelTabID)
	{
		
		var oRecFormWin;
		
		ga('send', 'event', g_VWS.ViewName() , 'Load', iRecordID);
		
		oRecFormWin= m_objMainDocRef.objFrames.GetFrameWindow(objMainDocRef.RECORD_FRAME_ID);
			
		//Make sure the form is ready to interact with us.
		if (oRecFormWin != null)
		{	
				
			//If the user is loading a different record...
			if(_me.GetRecordId() != iRecordID)
			{
				if (_me.OnBeforeNavigate)
				{
					// todo: move the event constant to a class
					_me.OnBeforeNavigate(CLOSE_SCENARIO_USER_LEAVES_ISSUE_CONTEXT);
				
				}
			}
				
			_me.SetRecordId(iRecordID);

			// Load the Record form from the correct URL. 
			// This should only be needed once since the form stays open but hidden 
			
			if (oRecFormWin.location.href.indexOf(MAIN_RECFORM_BASEURL)==-1)
			{
				oRecFormWin.location.replace(MAIN_RECFORM_BASEURL);
			}
			
			//SetState(COMMANDBAR_FRAME_ID, BUSY_STATE);
			//if(objFeatures.getFeature(FEATURE_RECORD)){
			
			// TODO: move controlsaction.View to here
			g_VWS.RecordMgr().CurrentRecord().Load( iRecordID, { TabToGoTo: iSelTabID  } );		
			
		} else {
			// just kill some time to let the command bar load
			// and then call the same function again
			var DELAY = 5;
			setTimeout(function(){
						_me.Load(iRecordID,iSelTabID);
					}, DELAY);
					
		}
		
		if(CMqBrowserDetector().mobile)
		{
			ResolveMobileScaling(true);
		}
		
	}
	

	function Hide()
	{
		g_VWS.MainWindow().ShowBusy(false);
		
		var objLoadRec=m_objMainDocRef.document.getElementById(LOAD_REC_CTNR);
		if(objLoadRec){
			
			if(CheckIfEmbedded() == true)
			{
				objLoadRec.style.display="none";
				g_VWS.MainWindow().ShowDisableMain(false);
			}
			else if(CheckIfInSeperateWindow() == true)
			{
				window.close();
			}
			else
			{
				if(g_VWS.RecordMgr().CurrentRecord().GetUseAnims() == true && CMqBrowserDetector().mobile == false)
				{
					ShowAnimateRecord(false);
				}
				else
				{
					objLoadRec.style.display="none";
					g_VWS.MainWindow().ShowDisableMain(false);
				}
			}
		}
		
		var objLoadRecOverlay = m_objMainDocRef.document.getElementById(LOAD_REC_OVERLAY_CTNR);
		if(objLoadRecOverlay)
		{
			objLoadRecOverlay.style.backgroundColor = "white";
		}
		
		if(CMqBrowserDetector().mobile)
		{
			ResolveMobileScaling(false);
		}
		g_VWS.RecordMgr().CurrentRecord().SetIsDocked(false);
	}
	
	
	function ShowLoadingUI(blnVisible, blnForceToFront)
	{
		var objLoadRecOverlay=m_objMainDocRef.document.getElementById(LOAD_REC_OVERLAY_CTNR);
		
		if(objLoadRecOverlay){
			if(blnForceToFront){
				objLoadRecOverlay.style.zIndex=9999;
			}else{
				objLoadRecOverlay.style.zIndex=1001;
			}
			if(blnVisible){
				objLoadRecOverlay.style.display="";
			}else{
				objLoadRecOverlay.style.display="none";
						
			}
		}
		
		//g_VWS.MainWindow().ShowBusy(blnVisible, blnForceToFront);
	}
	
	function Tabs()
	{
		return m_oTabs;
	}
	
	function IsVisible()
	{
		var blnReturn=false;
		var objLoadRec=m_objMainDocRef.document.getElementById(LOAD_REC_CTNR);
		if(objLoadRec)
		{
			blnReturn=(objLoadRec.style.display!="none");
		}
		return blnReturn;
	}
	
	this._GetRecordId=_GetRecordId;
	this.Initialize=Initialize;
	this.OnBeforeLoad=OnBeforeLoad;
	this.OnAfterLoad=OnAfterLoad;
	this.Show=Show;
	this.Hide=Hide;
	this.SetRecordId=SetRecordId;
	this.GetRecordId=GetRecordId;
	this.DisableRecord=DisableRecord;
	this.GetVisibleRecordId=GetVisibleRecordId;
	this.SynchronizeWithVisible=SynchronizeWithVisible;
	this.SynchronizeWithIntern=SynchronizeWithIntern;
	this.Resize=Resize;
	this.ShowLoadingUI=ShowLoadingUI;
	this.Tabs=Tabs;
	this.OnBeforeNavigate=null; // to be set from the outside
	this.Load=Load;
	this.IsVisible=IsVisible;
	
	//private static functions

	function _ResolveIssueID(strString, objMainDocRef, objRecordDisplay, objRecordId)
	{
		if(strString){
			var regExp=new RegExp("<ValOfField>1</ValOfField>","g");
			return strString.replace(regExp,_me._GetRecordId(objMainDocRef, objRecordDisplay, objRecordId));
		}
	}

	//private and static version of GetRecordId
	function _GetRecordId(objMainDocRef, objRecordDisplay, objRecordId)
	{
		if ((objRecordDisplay) && (objRecordId)){
			if (objRecordId.value===""){
				objRecordId.value=objMainDocRef.NO_CURRENT_RECORD;				
			}
			return Number(objRecordId.value);
		}else{
			return objMainDocRef.NO_CURRENT_RECORD;
		}
	}
	
	function _WriteTitleInfo(objMainDocRef, objControlsSs, objRecordDisplay, objRecordId)
	{
		var objTitle=objMainDocRef.document.getElementById("wizTitle");
		var objDesc=objMainDocRef.document.getElementById("wizDesc");
		var objMacros=new objMainDocRef.CMqMacros();
		var strTitleTemplate;
		var strDescTemplate;
		var objExistingIssueBtns=objMainDocRef.document.getElementById("ExistingIssueButtons");
		
		if(!objMainDocRef.g_VWS.RecordMgr().CurrentRecord().IsNewRecord()){
			strTitleTemplate=objMainDocRef.WIZARD_TITLE_EDIT;
			strDescTemplate=objMainDocRef.WIZARD_DESCRIPTION_EDIT;
			if(objExistingIssueBtns){
				objExistingIssueBtns.style.display="";
			}
		}else{
			strTitleTemplate=objMainDocRef.WIZARD_TITLE;
			strDescTemplate=objMainDocRef.WIZARD_DESCRIPTION;
			if(objExistingIssueBtns){
				objExistingIssueBtns.style.display="none";
			}
		}
		
		strTitleTemplate=_ResolveIssueID(strTitleTemplate, objMainDocRef, objRecordDisplay, objRecordId);
		strDescTemplate=_ResolveIssueID(strDescTemplate, objMainDocRef, objRecordDisplay, objRecordId);

		if(objMacros){	
			if(objTitle){			
				objTitle.innerHTML=objMacros.ResolveFieldMacros(strTitleTemplate,m_objLoadDataMgr,false, true);
			}
			if(objDesc){			
				objDesc.innerHTML=objMacros.ResolveFieldMacros(strDescTemplate,m_objLoadDataMgr,false, true);
			}
		}
	}

	function _SetRecordTabHeight(lngWinHeight, objMainDocRef)
	{
		var iRecHeaderHeight=125; // same as in objMainDocRef.document.getElementById("RecHeader").offsetHeight;
		var BUFFER_NO_SCROLL=2; //make the document smaller than the iframe so there's no scrollbar
		var intRecordHeightReduction=50; //in the event that a record tabs are not present, the record height should be reduced
		var intRecordHeightCorrection;
		
		//to distinguish between regular records and external records nested in dialogs
		if(CheckIfEmbedded() == true || CheckIfInSeperateWindow() == true)
		{
			//external nested 
			intRecordHeightCorrection=78;
		}
		else
		{
			//regular
			intRecordHeightCorrection=110;
		}
		
		var intRecHeight=lngWinHeight-iRecHeaderHeight-objMainDocRef.DEFAULT_TABS-objMainDocRef.DEFAULT_COMMANDBAR-objMainDocRef.DEFAULT_LOADDATA+intRecordHeightCorrection;
		var objRecFrame=objMainDocRef.document.getElementById(objMainDocRef.RECORD_FRAME_NAME);
		var objDivRec=objMainDocRef.document.getElementById("mbliOSRec");
		var intRecWidth = 100; //the percent value for the record's width
					
		if(objRecFrame){
			objRecFrame.style.height=intRecHeight+"px";
			objRecFrame.style.width= intRecWidth+"%";
			
			if(objDivRec != undefined) {
				if(objMainDocRef.DEFAULT_TABS == 0) {
					objDivRec.style.top = "90px"; //top value that better suits a record without tabs
					objRecFrame.style.height=intRecHeight-intRecordHeightReduction+"px";
				}
				else
				{
					objDivRec.style.top = "125px";
				}
			}
			
			objRecFrame=m_objFrames.GetFrameWindow(objMainDocRef.RECORD_FRAME_ID);
			
			if(objRecFrame){
				var objRecBody;
				
				if(objRecFrame.document){
					objRecBody=objRecFrame.document.body;
					if(objRecBody){
						objRecBody.style.height=intRecHeight-BUFFER_NO_SCROLL+"px";
					}
				}
			}
		}
	}
	
	function CheckIfEmbedded()
	{
		if(parent.document.location.href.toLowerCase()!= document.location.href.toLowerCase())
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	function CheckIfInSeperateWindow()
	{
		if($("#ToolBar"))
		{
			if($("#SummaryList").css("height") == "0px")
			{
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	
	function ShowAnimateRecord(Open)
	{
		var loadrec = $("#"+LOAD_REC_CTNR);
		
		if(loadrec)
		{
			if(Open == true)
			{
				loadrec.css("left","100%");
				g_VWS.MainWindow().ShowDisableMain(true);
				loadrec.show();
				loadrec.animate({left: "0"},500);
			}
			else
			{
				loadrec.animate({left: "100%"},500,function()
				{
					loadrec.hide();
					g_VWS.MainWindow().ShowDisableMain(false);
				});
			}
		}
	}
}





function CMqRecordMgr(objLoadData, objRequest, strFieldDelim, strFieldValueDelim)
{
	var _me=this;
	var m_objLoadData=objLoadData;
	var m_objRequest=objRequest;

	var m_oRecord;	// VNRecord
	var m_oVWS;
	_me.SaveOnlyChangedFields= true;
	_me.ReloadInterval = 0;
	var objFieldVals=m_objLoadData.GetObjFieldValues();
	
	if(objFieldVals){
		if(strFieldDelim){
			objFieldVals.SetFieldDelimiter(strFieldDelim);
		}
		
		if(strFieldValueDelim){
			objFieldVals.SetFieldValueDelimiter(strFieldValueDelim);
		}
	}


	function Save(lngRecordID, lngRevisionNumber, blnOnlyChangedFields, 
		strSaveURL, strAddRecQS, blnForceSave, lngSaveOnConflict, blnPropStrEnc)
	{
		var strResult="";
		var strQueryString="";
		
		if (!strSaveURL)
		{
			 strSaveURL=g_VWS.MainWindow().BaseURL() +"wcCmdBar.asp?wci=wciCommand&Command=Save";
		}
		
		ga('send', 'event', g_VWS.ViewName() , 'Save', lngRecordID);
		
		if(strAddRecQS){
			strQueryString += strAddRecQS;
		}

		if (blnOnlyChangedFields==null)
		{
			blnOnlyChangedFields=_me.SaveOnlyChangedFields;
		}

		strQueryString += m_objLoadData.GetDataForSave(blnOnlyChangedFields, blnPropStrEnc);
		if(strQueryString!=""){			
			var strReturn="";
			var strSaveURL;
			var strPostData;
		
			if(!lngSaveOnConflict){
				lngSaveOnConflict=0;
			}
			
			strPostData ="nId="+lngRecordID+"&nRevisionNumber="+lngRevisionNumber +
						"&bAcceptSave="+blnForceSave+"&bQueryString="+g_MqRef.MqStr.MqEncodeURIComponent(strQueryString) + 
						"&SOC="+lngSaveOnConflict;
			
			strReturn=m_objRequest.Post(strSaveURL,strPostData);

			if (strReturn!=m_objRequest.CANCEL_PROCESS){
				
									
				var objResponse=m_objRequest.Response(strReturn);
				if (objResponse){
					if (objResponse.HasErrors()){
						var objErrors=objResponse.GetErrors();
						if(objErrors){
							if(objErrors.Count()>0){
								var objErr=objErrors.Item(0);
								if(objErr){
									 if(String(objErr.GetNumber())=="-2147211944"){
										strResult="";
										if(window.confirm(objErr.GetText())){
											Save(lngRecordID,lngRevisionNumber,blnOnlyChangedFields, strSaveURL, strAddQS, blnForceSave, 1);
										}
									}else{
										strResult=objErr.GetText();
									}
								}
							}
						}
					}else{
						var objMsgContent=objResponse.GetContent();

						if(objMsgContent){
							strResult=objMsgContent.GetText();
							
							// Special case for required fields
							var re=new RegExp("The field (.+) is a required field. Please enter the required field before saving.","g");
							var arrMatches = re.exec(strResult);
							
							if (arrMatches)
							{
								strResult=g_MqRef.MqStr.Format(g_MqRef.RESX["WARNING_MESSAGE_REQUIRED_FIELD"], arrMatches[1]);
							}
							
						}
					}
				}
			}
		}
		
		return strResult;
	}
	
	
	function Fields()
	{
		return objFieldVals;
	}
	
	function OpenInNewSession(iID) 
	{

		var oWVO=new WebViewOpener(m_oVWS.URL(), m_oVWS.HTTPRequest() );
		
		if (this.WebViewOpenInNewSession!=="")
		{
			oWVO.Open(this.WebViewOpenInNewSession,false,iID);
		}
	
	}

	function CurrentRecord()
	{
		return m_oRecord;
	}

	function SetVecWebSession(oVWS)
	{
		m_oVWS = oVWS;
		
		// Initialize the CurrentRecord object
		m_oRecord = new VNRecord(m_oVWS);	
		
	}

		//** Save the specified fields to all the specified dts records 
	//**  Returns a string with a message if not full success.
	function SaveBatch( sRecIDs, sDataForSave )
	{
		var ret="";
					
		if ( m_objRequest && sDataForSave)
		{
			var url=g_VWS.MainWindow().ViewFolderURL() +"/html/wcCmdBar.asp?wci=wciCommand&Command=Batch";
			var sPost ="nId="+ sRecIDs + "&bQueryString="+ encodeURIComponent(sDataForSave);
			
			var co=m_objRequest.Post(url, sPost);
		
			if (co!=m_objRequest.CANCEL_PROCESS){					
				var objResponse=m_objRequest.Response(co);
				if (objResponse.HasErrors()){
					objResponse.ProcessErrors("",true);
				}else
				{
					var objMsg=objResponse.GetContent();
					if (objMsg){
						ret=objMsg.GetText();					
					}		
				}
			}			
		}	
		return ret;		
	}  


	
	this.WebViewOpenInNewSession="";	// e.g. "HelpDesk/Edit HelpDesk Ticket"
	this.Save=Save;
	this.Fields=Fields;
	this.CurrentRecord=CurrentRecord;
	this.SetVecWebSession=SetVecWebSession;
	this.OpenInNewSession=OpenInNewSession;
	this.SaveBatch=SaveBatch;
}



	

// Represents a VN Record . 
// Right now, the instance stays but is loaded with different ID and Revision when the 
// DTS Rec is loaded
function VNRecord(vecSession)
{
	const SUCCESS_SAVE= "-3";	
	const SAVE_CONFLICT= "-1";
	const RETRY_SAVE = "-10";
	const RELOAD = "-11";
	this.RETRY_SAVE = "-10";
	
	//const CANCEL_SAVE = "-11";
	const  INIT_REVISION_NUMBER ="0";
	const LOAD_REC_CTNR="loadRec";

	var _me=this;
	var m_oLoadDataMgr;	
	var m_oViewFlds;
	// Array of VNFormFields, one per field
	var m_arrFrmFlds = new Array();
	var m_iRecID=-1;
	var m_lngRevisionNumber=-1;
	const _vecSession=vecSession;
	
	var _useAnims = true;
	
	var m_blnIsDocked=false;
	
	if (vecSession)
	{
		m_oLoadDataMgr=vecSession.LoadDataMgr();	
		m_oViewFlds=vecSession.ViewFields();
		InitCustom();
	}
	
	function GetFormField(iFldID)
	{

		if (iFldID)
		{
			
			var oFrmFld=m_arrFrmFlds[iFldID];
			
			if (!oFrmFld)
			{
				// create a vn form field from the field definition
				var oFld=m_oViewFlds.Field(iFldID);
				
				if (oFld)
				{
					// Add to array
					oFrmFld= new VNFormField(oFld,m_oLoadDataMgr.GetDataHTMLDocumentObject());
					m_arrFrmFlds[iFldID]=oFrmFld;

				}	
					
			}
			return oFrmFld;
		}
	}

	// Shortcut to returns the value form element of a dts field
	function FldVals(iFldID)
	{

		if (iFldID)
		{
			// Get the vn form field
			const oVNFrmFld=_me.GetFormField(iFldID);
			
			return oVNFrmFld.GetValueControl();
								
		}
	}
	
	//g_VWS.RecordMgr().CurrentRecord().IsNewRecord()
	function IsNewRecord() 
	{
		if (_me.GetRevisionNumber() > 0) 
		{
			return false;
		}
		else
		{
			return true;
		}
	}
	
	//g_VWS.RecordMgr().CurrentRecord().SetRecID(x);
	function SetRecID(iRecID)
	{
		m_iRecID=iRecID;
		
		// Code assumes global objRecord. To be removed eventually.
		if(typeof(objRecord)!="undefined")
		{
			objRecord.SetRecordId(iRecID, true);
		}

	}
	
	//g_VWS.RecordMgr().CurrentRecord().GetRecID();
	function GetRecID()
	{
		return m_iRecID;
	}
	
	//g_VWS.RecordMgr().CurrentRecord().SetRevisionNumber(x);
	function SetRevisionNumber(lngRevisionNum)
	{
		m_lngRevisionNumber=lngRevisionNum;
	}
	
	//g_VWS.RecordMgr().CurrentRecord().GetRevisionNumber();
	function GetRevisionNumber()
	{
		return m_lngRevisionNumber;
	}
	
	// TODO: pass LoadDataMgr in constructor instead
	function ResolveMacros(sStr,oLoadDataMgr,bResolveChoiceIDsToText)
	{
		if (sStr && oLoadDataMgr && _vecSession.Macros){
			sStr=_vecSession.Macros.ResolveFieldMacros(sStr,oLoadDataMgr,
													true,bResolveChoiceIDsToText);
			        
		}
		return sStr;
	
	}
	
	function GetHTMLDocObj()
	{
		if (m_oLoadDataMgr)
		{
			return m_oLoadDataMgr.GetDataHTMLDocumentObject();
		}
	}
	
	function SetUseAnims(useAnims)
	{
		_useAnims = useAnims;
	}
	
	function GetUseAnims()
	{
		return _useAnims;
	}
	///remove recID and use internal?
	function Reload(recID)
	{
		if(objRecord)
		{
			if(objRecord.IsVisible())
			{
				if (!g_VWS.LoadDataMgr().FieldsAreChanged())
				{
					if(recID==objRecord.GetRecordId())
					{
						objControls.View(null, objTabsMgr.GetSelectedTabID());
					}
				}
			}
		}
	}

	/// Save the current record.
	function Save ( saveInfo )
	{
		return new Promise(  (resolveFunc , rejectFunc ) =>
		{
			//		TODO: make not global
			OnBeforeNavigate();		

			let doSave=false;
			if (LoadData.loaded)
			{
				// TODO:  blnAcceptSave=1 not used.
				var blnAcceptSave=0;				
				doSave=true;
				
				if (!blnAcceptSave)	{
					if ( _vecSession.CustomCode)
					{
						doSave= _vecSession.CustomCode.saveBefore( m_iRecID);
					}
				}else {
					doSave=blnAcceptSave;
				}
				
				if ( doSave)
				{
					doSave =ValidateRequiredFields();
				}
				
				if (doSave)
				{
					//		TODO: make not global
					if(m_objWorkFlow){
						m_objWorkFlow.OnSave();
					}
					
					var strQueryString=objCustomCode.CommitTimestamp();	
					
					if ( !saveInfo)
					{
						// Defaults if not passed.
						saveInfo={ LoadAfter: true};
					}
					saveInfo.RecordID= m_iRecID;
					saveInfo.RevisionNumber= m_lngRevisionNumber;
					saveInfo.PropStrEnc= true; // TODO: keep support for =false?
					
					if( saveInfo.QueryString)
					{
						saveInfo.QueryString+= strQueryString;
					}else
					{
						saveInfo.QueryString= strQueryString;
					}
					
					// Save, then a Custom processing, then the default processing (ProcessSaveResult)
					//_me.OnBeforeSaveUI(saveInfo ).then(
					_me.DoSave( saveInfo).then( _me.CustomProcessSaveResult ).then
						( ProcessSaveResult, ProcessFailedSave).then 
						(resolveFunc , rejectFunc);
						
				}
			}
			
			if (!doSave)
			{
				// if the save did not happen
				rejectFunc();
			}
		}	
		);

	}		

	/// Update UI before saving
	function OnBeforeSaveUI( saveInfo)
	{
		return new Promise(  (resolveFunc , rejectFunc )=>
		{
			_vecSession.MainWindow().ShowBusy(true);
			//ShowClickBlocker("Record");
			SetDocumentCursor("wait");			
			resolveFunc( saveInfo);
		});
	}
	
	///  saveInfo= {
	///         RecordID: lngRecordId, 
	///         RevisionNumber: lngRevisionNumber,		
	///         QueryString: strQueryString,  // query string used in the saving .
	///         PropStrEnc: true,		// TODO: consider making it a fixed constant
	///		Hidden:true,		
	///		ExtraQS: "&d=1",   	// additional query string used in the load record.
	///		TabToGoTo: 2,		// overrides StayOnCurrentTab
	///		StayOnCurrentTab: true	,
	///		LoadAfter: true		// reload the record if needed to see the latest changes. If false, usually the record form is closed.
	///		};
	function DoSave ( saveInfo )
	{
		return new Promise(  function (resolveFunc , rejectFunc )
		{
				const ret = _vecSession.RecordMgr().Save ( saveInfo.RecordID, saveInfo.RevisionNumber, saveInfo.OnlyChangedFields, 
																					saveInfo.SaveURL, saveInfo.QueryString,  saveInfo.ForceSave, saveInfo.SaveOnConflict, saveInfo.PropStrEnc);				

				if ( ret )
				{
					saveInfo.Result=ret;
					resolveFunc( saveInfo);
				}
				else
				{
					rejectFunc( saveInfo );
				}

		} );
	}

	/// placeholder; to be replaced by a custom handler.
	function CustomProcessSaveResult ( saveInfo )
	{	
		return new Promise(  (resolveFunc , rejectFunc ) =>
		{ 		
			resolveFunc( saveInfo);				
		});
	}

	/// Return a promise after processing the save result.
	/// This function may have UI interactions that need to be asynchronous.
	function ProcessSaveResult (  saveInfo)
	{
		return new Promise(  (resolveFunc , rejectFunc ) =>
		{ 			
			const saveResult = saveInfo.Result;
			
			if( saveResult)
			{
				if ( saveResult==SAVE_CONFLICT)
				{
					if (objCustomCode.onConflict(saveInfo.RecordID))
					{
						saveInfo.ForceSave=1;
						saveResult=_me.RETRY_SAVE;
						
					}else
					{
						if(objCustomCode.reloadAfterConflitCancel( saveInfo.RecordID)) 
						{
							saveResult=RELOAD;
						}
					}				
				
				}
				else
				{
					if ( saveResult == _me.RETRY_SAVE)
					{
						console.log("ProcessSaveResult retrying for record: " + saveInfo.RecordID);

						// The calls could be iterative/nested
						_me.DoSave( saveInfo).then( ProcessSaveResult, ProcessFailedSave).then(resolveFunc , rejectFunc );
						
					}
					else
					{
						// If all went well or it was cancelled, reload from the db
						if (  saveResult == SUCCESS_SAVE ||  saveResult == RELOAD)
						{
							if ( saveInfo.LoadAfter) 
							{
								//call async
								_me.Load( saveInfo.RecordID , saveInfo ); 
							}
							else
							{
								//see if the SL needs to be reloaded
								
									if(_vecSession.SummaryList().FieldChangedOnLastSave()){
										
										const loadDataFra=objFrames.GetFrameWindow(LOADDATA_FRAME_ID);
	
										if(loadDataFra){
											loadDataFra.RegenerateSumList(true, null, true);
										}
									}
								
								SetIdleStatus();
								_vecSession.MainWindow().ShowBusy( false);
								// HideClickBlocker("Record");		
								SetDocumentCursor("");
							}
							
							objCustomCode.saveAfter();			
							// Keep going if there's another function in the chain
							if ( typeof resolveFunc === "function")
							{
								resolveFunc (saveInfo);
							}
							
						}
						else
						{
							// treat it as a generic message and then a reject result.
							g_MqRef.MsgHlpr.DisplayMessage( saveResult).then( rejectFunc);
				
						}
						
					} 
				}
			}	
			else
			{
				rejectFunc( saveInfo );		
			}
		}
		);
		
	}
		
	function ProcessFailedSave( saveInfo)
	{
		return new Promise(  (resolveFunc , rejectFunc ) =>
		{
			_vecSession.MainWindow().ShowBusy(false); 		
			SetDocumentCursor("");	
			resolveFunc( saveInfo);				
		});
	}
	
	function ValidateRequiredFields()
	{
		if(m_objWorkFlow){
			return m_objWorkFlow.ValidateRequiredFields();
		}else{
			return true;
		}
	}

	///
	/// 	e.g. g_VWS.RecordMgr().CurrentRecord().Load( 23, loadParams);
	/// loadParams
	///		Hidden:true,
	///		ExtraQS: "&d=1",
	///		TabToGoTo: 2,			// overrides StayOnCurrentTab
	///		StayOnCurrentTab: true		
	function Load ( iRecID , loadParams)
	{
		// The rev number is loaded in tmplLoadData html around on AfterLoad 
		// TODO: call Fetch for load xml/json record here and skip loaddata.html
		SetRecID(iRecID);
		
		// TODO: callers passing true ?
		OnBeforeLoad(  false);	
		
		LoadDataRecord( loadParams );		
		
	}
	
	
	/// Previously in CMqRecord.
	/// Events called before loading record m_iRecID
	function OnBeforeLoad( bNewRec )
	{
		try
		{
			OnBeforeLoadUI( bNewRec );
			
			// Add here other onBeforeLoad per frame or UI area.
			const cmdBar=_vecSession.CommandBar();
			if ( cmdBar && cmdBar.OnBeforeLoad )
			{
				cmdBar.OnBeforeLoad( m_iRecID, bNewRec);
			}
		}catch(e)
		{ console.log(e);}
	}


	function OnBeforeLoadUI( bNewRec )
	{
		try
		{
			_vecSession.MainWindow().ShowBusy(true);
			ShowClickBlocker("Record");
			SetDocumentCursor("wait");
		}catch(e)
		{ console.log(e);}
	}
	
	/// loadParams
	///		Hidden:true,
	///		ExtraQS: "&d=1",
	///		TabToGoTo: 2,			// overrides StayOnCurrentTab
	///		StayOnCurrentTab: true		
	function LoadDataRecord( loadParams){
	
		
		var imgtochange;	
		var strShowQS="&Show=0";

		if (! loadParams.Hidden)
		{
			strShowQS="&Show=1";
		}
		
		if( loadParams.ExtraQS){
			strShowQS += loadParams.ExtraQS;
		}
		
		if (loadParams.TabToGoTo && loadParams.TabToGoTo>0 )
		{
			// leave it to go to the specific tab
		}
		else
		{
			if( loadParams.StayOnCurrentTab)
			{
				// TODO: remove global tabsmgr 
				loadParams.TabToGoTo=objTabsMgr.GetSelectedTabID();
			}
		}

		if (LoadData){						
			LoadData.location.replace("../html/wcCmdBar.asp?WCI=wciLoadData&nId="+m_iRecID + "&Tab=" + loadParams.TabToGoTo + strShowQS);
		}

	}
	
	/// Called from load data frame
	function OnAfterLoad( loadedID)
	{
		// Global in censusmain.js
		const EMPTY_DIR = "INIT";
		SetHiddenAttachFields("txtUploadDir", EMPTY_DIR);

		// The loadedID and Rev number are set in LoadDataMgr.Load once the rec is loaded 
		_me.OnAfterLoadUI( loadedID);		
	}
	
	/// loadedID = just loaded record
	function OnAfterLoadUI( loadedID )
	{	
		const cmdBarFra=objFrames.GetFrameWindow(COMMANDBAR_FRAME_ID);
		if(cmdBarFra){
			cmdBarFra.HandleSaveButtonState();
		}

		if( g_VWS.RecordMgr().CurrentRecord().IsNewRecord())
		{
			// TODO: still needed?
			m_lngRevisionNumber=INIT_REVISION_NUMBER;
		}
		
		// Only call show if the form is hidden
		if (_vecSession.MainDoc )
		{
			const loadRec= _vecSession.MainDoc.getElementById(LOAD_REC_CTNR);

			let bShow= true;
			
			if(loadRec && loadRec.style.display=="" )
			{	
				// if already shown, skip that
				bShow=false;
			}
			
			if (bShow)
			{
				objRecord.Show();
			}

		}

		_vecSession.MainWindow().ShowBusy( false);
		HideClickBlocker("Record");		
		SetDocumentCursor("");
		
		//SetState( LOADDATA_FRAME_ID, IDLE_STATE);
		//	SetState(COMMANDBAR_FRAME_ID, IDLE_STATE);
		//	SetIdleStatus();
		// TODO: consider this in SummaryList.OnAfterLoad 		
		//if (isRecordInLocalArray(intTempId)){
		//	intCurrentId=intTempId;
		//}

	}
	
	function Minimize()
	{
		var objMainWinDoc=g_VWS.MainWindow().GetDocument();
		if(objMainWinDoc){			
			var blnViewHasSL=objFeatures.getFeature(FEATURE_SUMLIST);
			var objLoadRec=objMainWinDoc.getElementById(LOAD_REC_CTNR);
			if(objLoadRec && blnViewHasSL){
				g_VWS.MainWindow().ShowDisableMain(false);
				objLoadRec.style.width = "50%";
				objLoadRec.style.left = "50%";
				objLoadRec.style.setProperty("border", "2px solid #666666", "important");
				objLoadRec.style.marginLeft="0%";
			}
			var objMaximizeBtn=objMainWinDoc.getElementById("maximizeBtn");
			if(objMaximizeBtn){
				objMaximizeBtn.style.display="";
			}
			
			var objMinimizeBtn=objMainWinDoc.getElementById("minimizeBtn");
			if(objMinimizeBtn){
				objMinimizeBtn.style.display="none";
			}
			SetIsDocked(true);
		}
	}
	
	function Maximize()
	{
		var objMainWinDoc=g_VWS.MainWindow().GetDocument();
		if(objMainWinDoc){		
			var blnViewHasSL=objFeatures.getFeature(FEATURE_SUMLIST);
			var objLoadRec=objMainWinDoc.getElementById(LOAD_REC_CTNR);
			if(objLoadRec && blnViewHasSL){
				objLoadRec.style.width = "92%";
				objLoadRec.style.left = "0px";
				objLoadRec.style.marginLeft = "8%";
				objLoadRec.style.border = "";
				
				g_VWS.MainWindow().ShowDisableMain(true);
			}
			
			
			var objMaximizeBtn=objMainWinDoc.getElementById("maximizeBtn");
			if(objMaximizeBtn){
				objMaximizeBtn.style.display="none";
			}
			var objMinimizeBtn=objMainWinDoc.getElementById("minimizeBtn");
			if(objMinimizeBtn){
				objMinimizeBtn.style.display="";
			}
			SetIsDocked(false);
		}
	}
	
	function SetIsDocked(blnIsDocked)
	{
		m_blnIsDocked = blnIsDocked;
	}
	
	function GetIsDocked()
	{
		return m_blnIsDocked;
	}
	
	/// Initialize built-in customizations (e.g. per project).
	function InitCustom()
	{
		// assign the default first.
		_me.CustomProcessSaveResult=CustomProcessSaveResult;
		
		if ( _vecSession && _vecSession.ProjectID>0 )
		{
			if (  _vecSession.ProjectID==_vecSession.Projects.RESOURCES )
			{
				if(typeof( g_VNLibs ) !="undefined")
				{
					// g_VNLibs not always present, as in AddAssets
					if(typeof( _vecSession.AssetMgr ) =="undefined")
					{
						_vecSession.AssetMgr= new g_VNLibs.VNAssetMgr();
					}

					if ( typeof( _me.CustomProcessSaveResult ) =="undefined" ||   _me.CustomProcessSaveResult.name != "OnProcessSaveResult" )
					{
						_me.CustomProcessSaveResult= _vecSession.AssetMgr.OnProcessSaveResult;		

					}
				}
			}
		}
	}
	
	function IsVisible()
	{
		let visible=false;
		if(objRecord)
		{
			visible=objRecord.IsVisible();
		}
		return visible;
	}
	
	function LoadWithData(lngRecID, strXML)
	{
		var oFieldValuesRs=new CMqRecordset(strXML, g_VWS.ViewFields().GetFieldIDName());	
		SetRecID(lngRecID);
		g_VWS.LoadDataMgr().Load(oFieldValuesRs,1, m_objDisplayElements,null, null, null, lngRecID, g_VWS.RecordMgr().CurrentRecord());
		
		//show the record
		objRecord.Show();
	}

	this.GetHTMLDocObj=GetHTMLDocObj;	
	this.IsNewRecord = IsNewRecord;
	this.FldVals=FldVals;
	this.GetFormField=GetFormField;
	this.SetRecID=SetRecID;
	this.GetRecID=GetRecID;
	this.SetRevisionNumber=SetRevisionNumber;
	this.GetRevisionNumber=GetRevisionNumber;
	this.ResolveMacros=ResolveMacros;
	this.SetUseAnims=SetUseAnims;
	this.GetUseAnims=GetUseAnims;
	this.Reload=Reload;
	this.Load=Load;
	this.DoSave=DoSave;
	this.Save=Save;
	this.OnAfterLoad=OnAfterLoad;
	this.OnAfterLoadUI=OnAfterLoadUI;
	this.OnBeforeSaveUI= OnBeforeSaveUI;
	this.Minimize=Minimize;
	this.Maximize=Maximize;
	this.SetIsDocked=SetIsDocked;
	this.GetIsDocked=GetIsDocked;
	this.IsVisible=IsVisible;
	this.LoadWithData=LoadWithData;
}

// Represents a VN Record Form
// TODO: consider initializing VNRec inside
function VNRecForm(oVNRec, oLoadDataMgr, oVecWebSession)
{
	var _me=this;
	var m_oVecWebSession=oVecWebSession;
	var m_oLoadDataMgr=oLoadDataMgr;	
	var m_oVNRec=oVNRec;
	
	
	function GetRecord()
	{
		return m_oVNRec;
	}

	
	function OpenURL(strURL,sWinName, oWinProp, blnAsChildWin)
	{             
		var MAX_URL_LEN=2020;
		if (!sWinName){
			sWinName="_blank";
		}

		// Resolve field macros to the current values if needed 
		m_oVNRec.ResolveMacros(strURL,m_oLoadDataMgr,_me.ResolveChoiceIDsToText);
		
		var objURIUtils=new CMqURIUtils();
		if(objURIUtils){
			strURL=objURIUtils.AddURIProtocol(strURL);
		}

	
		if (strURL.length>MAX_URL_LEN){
			strURL=strURL.substr(0,MAX_URL_LEN);
		}

		if(blnAsChildWin)
		{
			var oWin = new VNWindow(oWinProp.Modal);
			oWin.Open(strURL, sWinName, oWinProp.Width, oWinProp.Height, null, null, oWinProp.SizeMode);
			
		}else{
			window.open(strURL,sWinName);
		}
    }
	
	this.ResolveChoiceIDsToText=false;
	this.GetRecord=GetRecord;
	this.OpenURL=OpenURL;

}

function VNTabs()
{
	this.Visible=true;
}

function CMqCommandBar(mainWin, vecSession)
{
	const  _mainWin=mainWin;
	const _vecSession=vecSession;
	const _me=this;
	let _cmdBarDoc;
	this.BTN_OK = "OK";
	this.BTN_APPLY = "Apply";

	function SetDoc( cmdBarDoc )
	{
		_cmdBarDoc = cmdBarDoc;
	}
	
	function GetElement(sName)
	{


			// COMMANDBAR_FRAME_NAME in frameconstants.js
			if ( !_cmdBarDoc)
			{
				const frame=_mainWin.document.getElementById(COMMANDBAR_FRAME_NAME);

				if (frame)
				{
					const  win=frame.contentWindow;
				
					if (win)
					{
						_cmdBarDoc=win.document;
					}
				}
			}
			
			return _cmdBarDoc.getElementById(sName);

	}
	
	function AdjustSaveButton( resCaption, resTooltip, width, bDefault)
	{
		ModifyButton( _me.BTN_OK, resCaption, resTooltip, width, bDefault);
	}

	/// Executed  before loading a dts record. We update the buttons and other UI changes as needed.
	function OnBeforeLoad( iRecordID, bNew)
	{
		try
		{
			//console.log( "OnBeforeLoad:" + iRecordID + ", new:" + bNew);
			let sCaption ="";
			let sWidth="90px";	// default width
			
			if ( _me.SaveButtonCaption_New )
			{
				// If the caption is different for New records, determine if it's a new record or not
				if (bNew)
				{
					sCaption = _me.SaveButtonCaption_New;
					sWidth = "180px";
				}
				else
				{
					sCaption = _me.SaveButtonCaption;
				}
				_me.ModifyButton(  _me.BTN_OK, sCaption, sCaption, sWidth);
			}
		
			if ( _me.ApplyButtonCaption_New )
			{
				// If the caption is different for New records, determine if it's a new record or not
				if (bNew)
				{
					sCaption = _me.ApplyButtonCaption_New;
					sWidth = "180px";
				}
				else
				{
					sCaption = _me.ApplyButtonCaption;
				}
				_me.ModifyButton(  _me.BTN_APPLY, sCaption, sCaption, sWidth);
			}

			objControlsUi.disableControl(CONTROL_SAVE);
			objControlsUi.disableControl(CONTROL_CANCEL);
			
		}catch(e)
		{ console.log(e);}
	}
	
	/// sButtonName is not the id of the element but more a base name used to derive other element ids internally.
	function ModifyButton( sButtonName, resCaption, resTooltip, width, bDefault)
	{
		if (sButtonName)
		{
			try
			{
				var btn;
				
				if( resCaption)
				{
					btn = _me.GetElement("lnkAction" + sButtonName);
			
					if(btn )
					{
						btn.textContent=g_MqRef.RESX.Get(resCaption);
						btn.title=g_MqRef.RESX.Get(resTooltip);
						
					}
				}
				
				if( width )
				{
					btn = _me.GetElement("btnAction" + sButtonName);
			
					if(btn )
					{
						btn.style.width = width;
					}
				}
				
				if( bDefault)
				{
					btn = _me.GetElement("a_" + sButtonName);
			
					if(btn )
					{
						btn.classList.add("DefaultButton");
						btn.classList.remove("TextButtonStateDis");
						btn.classList.add("TextButtonState1");
						
					}
				}
			}catch(e)
			{ console.log(e);}
		}
	}

	/// Should the button Save and/or Apply be enabled?
	function IsSaveEnabled()
	{
		const QS_READONLY="RO";
		const QS_READONLY_YES="1";
		let enabled=false;
		
		if (!_vecSession.ViewFeatures().getFeature(parent.FEATURE_SURVEY_VIEW))
		{
			if (g_MqRef.MqStr.GetQueryStringValue( _mainWin.document.location.search, QS_READONLY )===QS_READONLY_YES)
			{			
				enabled=false;
			}else
			{
				if ( _vecSession.RecordMgr().CurrentRecord().IsNewRecord())
				{
					if (_vecSession.CommandBar().EnableSaveOnlyLastTab==true)
					{
						const lngCurrentTabIdx = GetCurrentTabIndex();
						if (lngCurrentTabIdx!=m_objRef.objTabsMgr.LastTabIdx())
						{
							enabled=false;
						}else{
							enabled=true;
						}
					}else
					{
						enabled=true;
					}
				}else
				{
					if( g_VWS.LoadDataMgr().FieldsAreChanged())
					{
						enabled=true;
					}
					else
					{
						enabled=false;
					}
				}
			}
		}else
		{
			enabled=true;
		}
		return enabled;
	}
		
	this.GetElement=GetElement;
	this.SaveButtonCaption=g_MqRef.RESX["BUTTON_OK"];
	this.SaveButtonTooltip=g_MqRef.RESX["BUTTON_SAVE_AND_CLOSE"];
	this.EnableSaveOnlyLastTab=false;
	this.SaveCommand="Save";
	this.CloseButtonCaption=g_MqRef.RESX['BUTTON_CLOSE'];
	this.CloseOnSave=false;
	this.BackButtonCaption="";//g_MqRef.RESX['BUTTON_BACK'];
	this.NextButtonCaption="";//g_MqRef.RESX['BUTTON_NEXT'];
	this.EnableApplyInNewRec=false;
	this.ApplyButtonCaption=g_MqRef.RESX["BUTTON_APPLY"];
	this.ApplyButtonTooltip=g_MqRef.RESX["BUTTON_SAVE"];
	this.AdjustSaveButton=AdjustSaveButton;
	this.ModifyButton=ModifyButton;
	this.OnBeforeLoad=OnBeforeLoad;
	this.SetDoc=SetDoc;
	this.IsSaveEnabled=IsSaveEnabled;
	
}

function VNQueryMgr()
{
	
	function Add(oQuery)
	{
		var request = 
		{
			"Name":oQuery.Name(),
			"IsGlobal":oQuery.IsGlobal(),
			"Conditions":oQuery.Conditions(),
			"ViewID":g_VWS.ViewID,
			"DefaultSort":oQuery.DefaultSort(),
			"DefaultLayout":oQuery.DefaultLayout()
		}
		
		g_MqRef.RESTClient.Initialize( g_VWS.URL().BaseVDURL() );
		var result=g_MqRef.RESTClient.Post("vzqry/" + g_VWS.ProjectID + "/Add/" + oQuery.ID(), JSON.stringify(request));
		result.then(OnResponseAdd);
	}
	
	function OnResponseAdd(response)
	{
		if (response)
		{
			if (response.Result==false)
			{
				g_MqRef.MsgHlpr.DisplayMessage( response ) ;
				for ( i=0; i<response.ErrorCodes.length; i++)
				{
					var msg=response.ErrorCodes[i].ErrorMessage;
					g_MqRef.MsgHlpr.DisplayMessage( msg ) ;
					 
				}
				
			}else{
				//refresh the list and select this one
				ForceViewQueryReload(response.Data, true);
				
				//close the caller dialog
				CloseWindow();
			}
		}
	}

	
	function Update(oQuery)
	{
		var request = 
		{
			"Name":oQuery.Name(),
			"Conditions":oQuery.Conditions(),
			"IsGlobal":oQuery.IsGlobal(),
			"DefaultSort":oQuery.DefaultSort(),
			"DefaultLayout":oQuery.DefaultLayout()
		}
		g_MqRef.RESTClient.Initialize( g_VWS.URL().BaseVDURL() );
		var result=g_MqRef.RESTClient.Post("vzqry/" + g_VWS.ProjectID + "/Update/" + oQuery.ID(), JSON.stringify(request));
		result.then(OnResponseUpdate);
	}
	
	function OnResponseUpdate(response)
	{
		if (response)
		{
			if (response.Result==false)
			{
				g_MqRef.MsgHlpr.DisplayMessage( response ) ;
				for ( i=0; i<response.ErrorCodes.length; i++)
				{
					var msg=response.ErrorCodes[i].ErrorMessage;
					g_MqRef.MsgHlpr.DisplayMessage( msg ) ;
					 
				}
				
			}else{
				//refresh the list and select this one
				ForceViewQueryReload(response.Data);
				
				//close the caller dialog
				CloseWindow();
			}
		}
	}
		
	function Rename(oQuery)
	{
		var request = 
		{
			"Name":oQuery.Name()
		}
		
		g_MqRef.RESTClient.Initialize( g_VWS.URL().BaseVDURL() );
		var result=g_MqRef.RESTClient.Post("vzqry/" + g_VWS.ProjectID + "/Rename/" + oQuery.ID(), JSON.stringify(request));
		result.then(OnResponseRename);
	}
	
	function OnResponseRename(response)
	{
		if (response)
		{
			if (response.Result==false)
			{
				g_MqRef.MsgHlpr.DisplayMessage( response ) ;
				for ( i=0; i<response.ErrorCodes.length; i++)
				{
					var msg=response.ErrorCodes[i].ErrorMessage;
					g_MqRef.MsgHlpr.DisplayMessage( msg ) ;
					 
				}
				
			}else{
				//refresh the list and select this one
				ForceViewQueryReload(response.Data);
				
			}
		}
	}
	
	function Delete(oQuery)
	{
		var request = {}
		
		g_MqRef.RESTClient.Initialize( g_VWS.URL().BaseVDURL() );
		var result=g_MqRef.RESTClient.Post("vzqry/" + g_VWS.ProjectID + "/Delete/" + oQuery.ID(), JSON.stringify(request));
		result.then(OnResponseDelete);
	}
	
	function OnResponseDelete(response)
	{
		if (response)
		{
			if (response.Result==false)
			{
				g_MqRef.MsgHlpr.DisplayMessage( response ) ;
				for ( i=0; i<response.ErrorCodes.length; i++)
				{
					var msg=response.ErrorCodes[i].ErrorMessage;
					g_MqRef.MsgHlpr.DisplayMessage( msg ) ;
					 
				}
				
			}else{
				//refresh the list and select the first one
				ForceViewQueryReload(-1);	

				//close the caller dialog
				CloseWindow();				
			}
		}
	}
	
	function Copy(oQuery)
	{
		var request = 
		{
			"Name":oQuery.Name(),
			"ViewID":g_VWS.ViewID
		}
		
		g_MqRef.RESTClient.Initialize( g_VWS.URL().BaseVDURL() );
		var result=g_MqRef.RESTClient.Post("vzqry/" + g_VWS.ProjectID + "/Copy/" + oQuery.ID(), JSON.stringify(request));
		result.then(OnResponseCopy);
	}
	
	function OnResponseCopy(response)
	{
		if (response)
		{
			if (response.Result==false)
			{
				g_MqRef.MsgHlpr.DisplayMessage( response ) ;
				for ( i=0; i<response.ErrorCodes.length; i++)
				{
					var msg=response.ErrorCodes[i].ErrorMessage;
					g_MqRef.MsgHlpr.DisplayMessage( msg ) ;
					 
				}
				
			}else{
				//refresh the list and select this one
				ForceViewQueryReload(response.Data);
				
				//close the caller dialog
				CloseWindow();
			}
		}
	}
	
	function RemoveFromView(oQuery)
	{
		var request = 
		{
			"ViewID":g_VWS.ViewID
		}
		
		g_MqRef.RESTClient.Initialize( g_VWS.URL().BaseVDURL() );
		var result=g_MqRef.RESTClient.Post("vzqry/" + g_VWS.ProjectID + "/Remove/" + oQuery.ID(), JSON.stringify(request));
		result.then(OnResponseRemoveQueryFromView);
	}
	
	function OnResponseRemoveQueryFromView(response)
	{
		if (response)
		{
			if (response.Result==false)
			{
				g_MqRef.MsgHlpr.DisplayMessage( response ) ;
				for ( i=0; i<response.ErrorCodes.length; i++)
				{
					var msg=response.ErrorCodes[i].ErrorMessage;
					g_MqRef.MsgHlpr.DisplayMessage( msg ) ;
					 
				}
			
			}else{
				//refresh the list, select the first one
				ForceViewQueryReload(-1);
			}
		}
	}

	function ForceViewQueryReload(lngQueryToLoad, blnClearFilters)
	{
		m_objRef.g_VWS.Queries().Load();
		
		if(lngQueryToLoad < 0)
		{
			//get the first one in the list (alphabetically)
			var objFirstQry=m_objRef.g_VWS.Queries().GetFirst(true);
			
			if(objFirstQry){
				debugger;
				lngQueryToLoad=objFirstQry.ID();
			}else{
				lngQueryToLoad=0;
			}
		}
		
		if(lngQueryToLoad)
		{
			if(blnClearFilters)
			{
				m_objRef.m_objSLInput.SetAdhocFilters("");
				if(objFrames)
				{
					objFrames.GetFrameWindow(TOOLBARB_FRAME_ID).refreshFilterUI();
				}
			}
			
			if(objFrames)
			{
				objFrames.GetFrameWindow(TOOLBAR_FRAME_ID).RunQueryFromList(lngQueryToLoad);
			}
		}
	}
	
	function Get(id)
	{
		var oQuery=new VNQuery();
		var request = {}
		
		var strReturn=g_VWS.HTTPRequest().Post(g_VWS.URL().BaseVDURL() + "/vzqry/" + g_VWS.ProjectID + "/Get/" + id,JSON.stringify(request));
		
		var objResponse=g_VWS.HTTPRequest().Response(strReturn);
		
		if (objResponse){
			if (objResponse.HasErrors()){
				objResponse.ProcessErrors()
				
			}else{
				var objData=objResponse.GetData();

				if(objData){
					//Load a VNQuery object to return
					oQuery.Load(objData);
				}
			}
		}
		return oQuery;
	}
	
	this.Add=Add;
	this.Update=Update;
	this.Rename=Rename;
	this.RemoveFromView=RemoveFromView;
	this.Get=Get;
	this.Delete=Delete;
	this.Copy=Copy;
}

function VNQuery(id, name, isGlobal, conditions, defaultSort, defaultLayout)
{
	var _id=0;
	var _name="";
	var _isGlobal=false;
	var _conditions=new Array();
	var _defaultSort=0;
	var _defaultLayout=0;
	var _conditionsStr="";
	var _conditionsCanBeModified=false;
	
	SetID(id);
	SetName(name);
	SetIsGlobal(isGlobal);
	SetConditions(conditions);
	SetDefaultSort(defaultSort);
	SetDefaultLayout(defaultLayout);
	
	
	
	function SetID(val)
	{
		if(val){
			_id=val;
		}
	}
	
	function SetName(val)
	{
		if(val){
			_name=val;
		}
	}
	
	function SetIsGlobal(val)
	{
		if(val){
			_isGlobal=val;
		}
	}
	
	function SetConditions(val)
	{
		if(val){
			_conditions=val;
		}
	}
	
	function SetDefaultSort(val)
	{
		if(val){
			_defaultSort=val;
		}
	}
	
	function SetDefaultLayout(val)
	{
		if(val){
			_defaultLayout=val;
		}
	}
	
	function SetConditionsStr(val)
	{
		if(val){
			_conditionsStr=val;
		}
	}
	
	function SetConditionsCanBeModified(val)
	{
		if(val){
			_conditionsCanBeModified=val;
		}
	}
	function Load(objData)
	{
		SetID(objData.ID);
		SetName(objData.Name)
		SetIsGlobal(objData.IsGlobal);
		SetConditions(objData.Conditions);
		SetDefaultSort(objData.DefaultSort);
		SetDefaultLayout(objData.DefaultLayout);
		SetConditionsStr(objData.ConditionsStr);
		SetConditionsCanBeModified(objData.ConditionsCanBeModified);

	}
	function ID()
	{
		return _id;
	}
	
	function Name()
	{
		return _name;
	}
	
	function IsGlobal()
	{
		return _isGlobal;
	}
	
	function Conditions()
	{
		return _conditions;
	}
	
	function DefaultSort()
	{
		return _defaultSort;
	}
	
	function DefaultLayout()
	{
		return _defaultLayout;
	}
	
	function ConditionsStr()
	{
		return _conditionsStr;
	}
	
	function ConditionsCanBeModified()
	{
		return _conditionsCanBeModified;
	}
	
	this.Load=Load;
	this.ID=ID;
	this.Name=Name;
	this.IsGlobal=IsGlobal;
	this.Conditions=Conditions;
	this.DefaultSort=DefaultSort;
	this.DefaultLayout=DefaultLayout;
	this.ConditionsStr=ConditionsStr;
	this.ConditionsCanBeModified=ConditionsCanBeModified;
}

function VNQueryCol()
{
	var m_oQryCol=new Array();
	var m_oQryColAlpha=new Array();
	
	function GetQueryCol(blnAlphabetically)
	{
		if(blnAlphabetically){
			return m_oQryColAlpha;
		}else{
			return m_oQryCol;
		}
	}
	
	function Load()
	{			
		var request = {}
		m_oQryCol=new Array();
		m_oQryColAlpha=new Array();
		
		var strReturn=g_VWS.HTTPRequest().Post(g_VWS.URL().BaseVDURL() + "/vzqry/" + g_VWS.ProjectID + "/GetAll/" + g_VWS.ViewID,JSON.stringify(request));
		var objResponse=g_VWS.HTTPRequest().Response(strReturn);
		
		if (objResponse){
			if (objResponse.HasErrors()){
				objResponse.ProcessErrors()
				
			}else{
				var objData=objResponse.GetData();

				if(objData){
					for(x=0; x<objData.length; x++)
					{
						//Load a VNQuery object
						var qry = new VNQuery();
						qry.Load(objData[x]);
						m_oQryCol[qry.ID()]=qry;		
					}
				}
			}
		}
		
		//load the other collection alphabetically (the index will not be the query ID)
		m_oQryColAlpha = m_oQryCol.slice();
		m_oQryColAlpha.sort((a,b) => (a.Name() > b.Name()) ? 1 : ((b.Name() > a.Name()) ? -1 : 0));
	}	
	
	function GetFirst(blnAlphabetically)
	{
		var oFirstQuery;
		
		//get the first one in the collection
		var oQueries=GetQueryCol(blnAlphabetically);
		
		if(oQueries){
			for(x=0; x<oQueries.length; x++){
				if(oQueries[x]){
					oFirstQuery=oQueries[x];
					break;					
				}
			}
		}
		return oFirstQuery;
	}
	
	this.Load=Load;
	this.GetQueryCol=GetQueryCol;
	this.GetFirst=GetFirst;
}
